<?php
	call_user_func(function(){
		$sql_join = '';
		$sql_where = array();
		if (!empty($_REQUEST['sc_id']))
		{
			$sc_id = $_REQUEST['sc_id'];
			$sql_join = "JOIN (
					SELECT
						`id_trip`
					FROM
						`trip`
					WHERE
						`id_schedule` in ($sc_id)
				) tr";
			$sql_where[] = "FIND_IN_SET(tr.`id_trip`, `order`.`from`) > 0";
		}
		if (!empty($_REQUEST['b_id']))
		{
			$b_id = $_REQUEST['b_id'];
			$sql_where[] = "`order`.`id_order` in ($b_id)";
		}
		if (empty($sql_where)) return json_exit('400','error','empty sc_id and b_id');
		$sql_where = implode(' AND ',$sql_where);

		if (isset($_REQUEST['only_list']))
		{
		$s = "SELECT
				`order`.`id_order` as b_id
			FROM  `order`
			$sql_join
			WHERE 
				$sql_where";

			$q = query($s);
			if ($q === false) json_exit('400','error','database select error : '. error_db());

			$data = array();
			while ($d = fetch_assoc($q))
			{
				$data[] = $d['b_id'];
			}
			json_exit('200','success',NULL,$data);
		}

		$s = "SELECT
				`order`.`id_order` as b_id,
				`order`.`id_order_status` as b_state,
				`order`.`create_datetime` as b_created,
				`order`.`id_payment_method` as b_payment_way,
				`order`.`confirm_limit_datetime` as b_confirmation_limit,
				`order`.`sum` as b_payment_sum,
				`order`.`pay_datetime` as b_payment_datetime,
				`order`.`options` as b_options,
				`order`.`currency` as b_currency,
				`users`.`id_user` as u_id,
				`users`.`id_role` as u_role,
				`users`.`name` as u_name,
				`users`.`family` as u_family,
				`users`.`middle` as u_middle,
				`users`.`phone` as u_phone,
				`users`.`email` as u_email
			FROM  `order`
			$sql_join
			LEFT JOIN `users` ON `users`.`id_user` = `order`.`client`
			WHERE
				$sql_where";

		$q = query($s);
		if ($q === false) json_exit('400','error','select error : '. error_db());

		$data = array();
		$sql_ticket = array();
		$order = array();
		while ($d = fetch_assoc($q))
		{
			$d['b_options'] = json_decode($d['b_options'],true);
			if (empty($d['b_options']['tickets']['seats'])) json_exit('400','error',$d['b_id'] . ' with empty seats');
			while (true)
			{
				$trips_seats = empty($d['b_options']['tickets']['seats']) ? array() : $d['b_options']['tickets']['seats'];
				$d['b_options']['tickets']['seats'] = $trips_seats;
				if (!is_array($trips_seats)) break;
				if (empty($trips_seats)) break;
				foreach($trips_seats as $id_trip=>$seats)
				{
					if (!is_array($seats)) break;
				}

				foreach($d['b_options']['tickets']['t_id'] as $t_id=>$sc_id)
				{
					$seat_id_arr = array();
					foreach($trips_seats[$t_id] as $seat_id=>$price)
					{
						$seat_id_arr[] = $seat_id;
					}
					$sql_ticket[] = "(`id_trip` ='$t_id' AND `id_trip_seat` in ('" . implode("','",$seat_id_arr) . "'))";
				}
				break;
			}
			$data[] = $d;
			$order[] = $d['b_id'];
		}

		$redirect_arr = array();
		if (empty($_REQUEST['redirect']))
		{
			if (!empty($order))
			{
				while (true)
				{
					$post_data = array(
						'data'	=>	array(
							url('',0,1) =>	array(
								CONFIG	=>	$order
							)
						),
						'hash'	=>	"It's~admin_post"
					);

					$c = curl_init();
					curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
					curl_setopt($c,CURLOPT_URL, "http://77.237.233.158:5001/get_order_by_admin",);
					curl_setopt($c,CURLOPT_POST, 1);
					curl_setopt($c,CURLOPT_POSTFIELDS,json_encode($post_data));
					curl_setopt($c,CURLOPT_CAINFO,$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
					curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 60);
					curl_setopt($c, CURLOPT_TIMEOUT, 60);
					$headers = array(
						"Content-Type: application/json"
					);
					curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
					$response = curl_exec($c);
					if (empty($response)) break;
					@$response = json_decode($response,true);
					if (empty($response) || !is_array($response))
					{
						 break;
					}
					if (!empty($response['error']))
					{
						break;
					}
					if (empty($response['data']))
					{
						break;
					}
					foreach($response['data'] as $order_arr)
					{
						$redirect_arr[$order_arr['order']] = $order_arr['redirect'];
					}
					break;
				}
			}
		}
		else
		{
			@$redirect_import = json_decode($_REQUEST['redirect'],true);
			if (is_array($redirect_import)) $redirect_arr = $redirect_import;
		}

		$fix_seats = array();
		$codes = array();
		$status_arr = array();
		$number_arr = array();
		if (!empty($sql_ticket))
		{
			$sql_ticket = implode(" OR ", $sql_ticket);
			$s = "SELECT
					`id_trip`,
					`id_seat`,
					`id_trip_seat`,
					`code`,
					`status`,
					`number`
				FROM `ticket`
				WHERE $sql_ticket
				";

			$q = query($s);
			if ($q === false) json_exit('400','error','ticket select error : '. error_db());

			while ($d_t = fetch_assoc($q))
			{
				$fix_seats[$d_t['id_trip']][$d_t['id_trip_seat']] = $d_t['id_seat'];
				$codes[$d_t['id_trip']][$d_t['id_trip_seat']] = $d_t['code'];
				$status_arr[$d_t['id_trip']][$d_t['id_trip_seat']] = $d_t['status'];
				$number_arr[$d_t['id_trip']][$d_t['id_trip_seat']] = $d_t['number'];
			}
		}

		$out = array();
		$csv_title_list_arr = array();
		$csv_title_list_arr['идентификатор заказа'] = true;
		$csv_title_list_arr['идентификатор статуса заказа'] = true;
		$csv_title_list_arr['дата создания заказа'] = true;
		$csv_title_list_arr['идентификатор способа оплаты'] = true;
		$csv_title_list_arr['дата истечения оплаты заказа'] = true;
		$csv_title_list_arr['общая сумма заказа'] = true;
		$csv_title_list_arr['дата оплаты заказа'] = true;
		$csv_title_list_arr['идентификатор клиента'] = true;
		$csv_title_list_arr['идентификатор роли клиента'] = true;
		$csv_title_list_arr['имя клиента'] = true;
		$csv_title_list_arr['фамилия клиента'] = true;
		$csv_title_list_arr['отчество клиента'] = true;
		$csv_title_list_arr['телефон клиента'] = true;
		$csv_title_list_arr['емейл клиента'] = true;
		$csv_title_list_arr['статус оплаты'] = true;

		$csv_title_list_arr['идентификатор события'] = true;
		$csv_title_list_arr['идентификатор блока билетов'] = true;
		$csv_title_list_arr['числовой илентификатор места'] = true;
		$csv_title_list_arr['илентификатор места'] = true;
		$csv_title_list_arr['категория места'] = true;
		$csv_title_list_arr['ряд места'] = true;
		$csv_title_list_arr['номер места'] = true;
		$csv_title_list_arr['цена билета на место'] = true;
		$csv_title_list_arr['код доступа на мероприятия'] = true;
		$csv_title_list_arr['идентификатор статуса билета'] = true;
		$csv_title_list_arr['название места'] = true;

		$csv_title_list_arr['utm_source'] = true;
		$csv_title_list_arr['utm_medium'] = true;
		$csv_title_list_arr['utm_campaign'] = true;
		$csv_title_list_arr['utm_id'] = true;
		$csv_title_list_arr['utm_content'] = true;
		$csv_title_list_arr['utm_term'] = true;

		foreach($data as $d)
		{
			$out_add_flag = false;
			add_time_zone($d['b_created']);
			add_time_zone($d['b_confirmation_limit']);
			add_time_zone($d['b_payment_datetime']);

			$data_row = array();
			$data_row['идентификатор заказа'] = $d['b_id'];
			$data_row['идентификатор статуса заказа'] = $d['b_state'];
			$data_row['дата создания заказа'] = $d['b_created'];
			$data_row['идентификатор способа оплаты'] = $d['b_payment_way'];
			$data_row['дата истечения оплаты заказа'] = $d['b_confirmation_limit'];
			$data_row['общая сумма заказа'] = round((float)$d['b_payment_sum'],2) . ' ' . $d['b_currency'];
			$data_row['дата оплаты заказа'] = $d['b_payment_datetime'];
			$data_row['идентификатор клиента'] = $d['u_id'];
			$data_row['идентификатор роли клиента'] = $d['u_role'];
			$data_row['имя клиента'] = $d['u_name'];
			$data_row['фамилия клиента'] = $d['u_family'];
			$data_row['отчество клиента'] = $d['u_middle'];
			$data_row['телефон клиента'] = $d['u_phone'];
			$data_row['емейл клиента'] = $d['u_email'];
			$data_row['статус оплаты'] = isset($d['b_options']['tickets']['payment']) ? $d['b_options']['tickets']['payment'] : NULL;
			if (!empty($redirect_arr[$d['b_id']]))
			{
				$url_query = parse_url($redirect_arr[$d['b_id']], PHP_URL_QUERY);
				if ($url_query !== false && $url_query !== NULL)
				{
					parse_str($url_query, $query_arr);
					if (!empty($query_arr['appUrl']))
					{
						$query_arr['appUrl'] = trim($query_arr['appUrl']);
						$taxiAppUrl = $query_arr['appUrl'];
						if (substr($taxiAppUrl,0,1) === '{')
						{
							@$taxiAppUrl = json_decode($taxiAppUrl,true);
							if (empty($taxiAppUrl) || !is_array($taxiAppUrl))
							{
								$taxiAppUrl = $query_arr['appUrl'];
							}
							else
							{
								$taxiAppUrl = isset($taxiAppUrl['failed']) ? $taxiAppUrl['failed'] : (isset($taxiAppUrl['succeeded']) ? $taxiAppUrl['succeeded'] : '');
							}
						}
						$url_query = parse_url($taxiAppUrl, PHP_URL_QUERY);
						if ($url_query !== false && $url_query !== NULL)
						{
							parse_str($url_query, $query_arr);
							foreach($query_arr as $key=>$val)
							{
								if (substr($key,0,3) == 'utm')
								{
									$data_row[$key] = $val;
									$csv_title_list_arr[$key] = true;
								}
							}
						}
					}
				}
			}

			$trips_seats = $d['b_options']['tickets']['seats'];
			if (!empty($trips_seats))
			{
				foreach($d['b_options']['tickets']['t_id'] as $t_id=>$sc_id)
				{
					foreach($trips_seats[$t_id] as $seat_id=>$price)
					{
						$data_row_this = $data_row;
						$data_row_this['идентификатор события'] = $sc_id;
						$data_row_this['идентификатор блока билетов'] = $t_id;

						$data_row_this['числовой илентификатор места'] = $seat_id;
						$id_trip_seat = $seat_id;
						$seat_id = isset($fix_seats[$t_id][$seat_id]) ? $fix_seats[$t_id][$seat_id] : $seat_id;
						$seat_s_b_r_s = explode(';',$seat_id);
						if (count($seat_s_b_r_s) < 4)
						{
							$parsed_block = '';
							$parsed_row = '';
							$parsed_seat = $seat_id;
						}
						else
						{
							$parsed_block = $seat_s_b_r_s[1];
							$parsed_row = $seat_s_b_r_s[2];
							$parsed_seat = $seat_s_b_r_s[3];
						}
						$data_row_this['илентификатор места'] = $seat_id;
						$data_row_this['категория места'] = $parsed_block;
						$data_row_this['ряд места'] = $parsed_row;
						$data_row_this['номер места'] = $parsed_seat;
						$data_row_this['цена билета на место'] = round_price($price,2);
						$data_row_this['код доступа на мероприятия'] = isset($codes[$t_id][$id_trip_seat]) ? $codes[$t_id][$id_trip_seat] : '';
						$data_row_this['идентификатор статуса билета'] = isset($status_arr[$t_id][$id_trip_seat]) ? $status_arr[$t_id][$id_trip_seat] : '';
						$data_row_this['название места'] = isset($number_arr[$t_id][$id_trip_seat]) ? $number_arr[$t_id][$id_trip_seat] : '';
						$out[] = $data_row_this;
						$out_add_flag = true;
					}
				}
			}
			if ($out_add_flag === false) $out[] = $data_row;
		}

		$i_title = false;
		$null_str = '';
		$delimiter = '^';
		$not_exist_str = '';
		$csv_title_list_arr = array_keys($csv_title_list_arr);
		$arr = $out;

		$escaped_delimiter = strtr($delimiter,array(']'=>'\\]','\\'=>'\\\\'));
		$reg = "/[\\r\\n\"$escaped_delimiter]/";

		$csv = array();
		if (is_array($arr) && count($arr))
		{
			$csv_title_list = array();
			$csv_title_key = array();
			if (!empty($csv_title_list_arr) && is_array($csv_title_list_arr))
			{
				foreach($csv_title_list_arr as $key)
				{
					$csv_title_list[] = $key;
					$csv_title_key[$key] = true;
				}
			}
			if ($i_title !== false)
			{
				if (!isset($csv_title_key[$i_title])){
					$csv_title_list[] = $i_title;
					$csv_title_key[$i_title] = true;
				}
			}
			$str = array();
			if ($i_title === false){
				foreach($arr as $row)
				{
					if (!is_array($row)) continue;
					$str = array();
					foreach($csv_title_list as $key)
					{
						if (array_key_exists($key,$row))
						{
							$val = $row[$key];
							unset($row[$key]);
							if ($val === NULL)
							{
								$val = $null_str;
							} 
							elseif (is_array($val)) 
							{
								$val = json_encode($val);
							}
						}
						else
						{
							$val = $not_exist_str;
						}
						if (preg_match($reg,$val)) $val = '"' . str_replace('"','""',$val) . '"';
						$str[] = $val;
					}
					foreach($row as $key=>$val)
					{
						$csv_title_list[] = $key;
						$csv_title_key[$key] = true;
						if ($val === NULL)
						{
							$val = $null_str;
						} 
						elseif (is_array($val)) 
						{
							$val = json_encode($val);
						}
						if (preg_match($reg,$val)) $val = '"' . str_replace('"','""',$val) . '"';
						$str[] = $val;
					}
					$csv[] = implode($delimiter,$str);
				}
			} else {
				foreach($arr as $i=>$row)
				{
					if (!is_array($row)) continue;
					$str = array();
					foreach($csv_title_list as $key)
					{
						if (array_key_exists($key,$row))
						{
							$val = $row[$key];
							unset($row[$key]);
							if ($val === NULL)
							{
								$val = $null_str;
							}
							elseif (is_array($val)) 
							{
								$val = json_encode($val);
							}
						}
						elseif ($key == $i_title)
						{
							$val = $i;
						}
						else
						{
							$val = $not_exist_str;
						}
						if (preg_match($reg,$val)) $val = '"' . str_replace('"','""',$val) . '"';
						$str[] = $val;
					}
					foreach($row as $key=>$val)
					{
						$csv_title_list[] = $key;
						$csv_title_key[$key] = true;
						if ($val === NULL)
						{
							$val = $null_str;
						}
						elseif (is_array($val))
						{
							$val = json_encode($val);
						}
						if (preg_match($reg,$val)) $val = '"' . str_replace('"','""',$val) . '"';
						$str[] = $val;
					}
					$csv[] = implode($delimiter,$str);
				}
			}
			$str = array();
			foreach($csv_title_list as $key){
				if (preg_match($reg,$key))
				{
					$key = '"' . str_replace('"','""',$key) . '"';
				}
				$str[] = $key;
			}
			array_unshift($csv,implode($delimiter,$str));
		}
		$csv = chr(0xEF) . chr(0xBB) . chr(0xBF) . implode("\n",$csv);
		echo $csv;
		exit;
	});