<?php
	date_default_timezone_set('Europe/Kiev');
    set_time_limit(0);
	ini_set('display_errors', '1');
	ini_set('display_startup_errors', '1');
	error_reporting(E_ALL);
//	error_reporting(E_ERROR);
	require_once('load_constant.php'); 
	define('CONFIG_URL_ROUTE', trim('c'));
	require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'models/m_routing.php');
	if (isset($_REQUEST['debug']))
	{
		class debug {public static $data = array();}
		debug::$data['$GLOBALS'] = $GLOBALS;
		unset(debug::$data['$GLOBALS']['GLOBALS']);
		debug::$data['php://input'] = file_get_contents('php://input');
		debug::$data['time'] = microtime(true);
		function errorHandler($errno, $errstr, $errfile, $errline)
		{
			debug::$data['error'][] = compact('errno','errstr','errfile','errline');
			return false;
		}
		function shutdown()
		{
			$log = $_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/req.log';
			file_put_contents($log,json_encode(debug::$data)."\n",FILE_APPEND);
		}
		set_error_handler("errorHandler");
		register_shutdown_function('shutdown');
	}
	if (!file_exists($_SERVER['DOCUMENT_ROOT'] . ROOT_URL))
	{
		$_GET['route'] = 'api';
		$_GET['par'] = array('error' => 'root not found');
		require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_api.php');

	}
	if (!defined('CONFIG'))
	{
		if (isset($_GET['config']) && strlen($_GET['config'] = trim($_GET['config'])) > 0)
		{

			define('CONFIG', $_GET['config']);

		}
		else
		{
			define('CONFIG', '0');
		}
		define('CONFIG_FROM_PATH',false);
	}
	else
	{
		define('CONFIG_FROM_PATH',true);

	}
	if (!preg_match('/^[0-9A-z_.-]+$/',CONFIG))
	{
		$_GET['route'] = 'api';
		$_GET['par'] = array('error' => 'config with wrong chars');
		require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_api.php');
	}
	if (!(@include_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/list/' . CONFIG . '/index.php')))
	{
		$_GET['route'] = 'api';
		$_GET['par'] = array('error' => 'config not found');
		require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_api.php');
	}

	define('HOST', $config_arr['HOST']);
	define('DBNAME', $config_arr['DBNAME']); 
	define('USERNAME', $config_arr['USERNAME']);
	define('PASSWORD', $config_arr['PASSWORD']);

	define('CONFIG_URL', ROOT_URL . CONFIG_URL_ROUTE . '/' . CONFIG . '/');
	define('CONFIG_CACHE', ROOT_URL . 'cache/data' . (CONFIG ? '_' . CONFIG : ''));
	class taxi {public static $data = array(); public static $version = ''; public static $check_auth_user_count = 0;public static $id_role = NULL; public static $data_private = array(); public static $data_stt = array(); public static $version_stt = ''; public static $data_sc = array(); public static $version_sc = '';}
	@include_once($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.php');
	@include_once($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.(stt).php');
	@include_once($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.(sc).php');
	define('FILE_PATH', ROOT_URL . trim('files/'));
	define('CONFIG_FOLDER', ROOT_URL . CONFIG_URL_ROUTE . 'f/' . CONFIG . '/');
	define('CONFIG_FILE_PATH', CONFIG_FOLDER . trim('files/'));
	define('CONFIG_USER_FILE_PATH', CONFIG_FOLDER . trim('files_u/'));
	define('STRIP_ROOT', str_replace('/','_',preg_replace('/\/$/','',ROOT_URL,1))); 
	define('UID_SUFFIX',STRIP_ROOT.(CONFIG ? '-' . CONFIG : ''));
	define('UID','UID'.':'.ROOT_URL.':'.CONFIG);

	if (!empty(taxi::$data['site_constants']['the_language_of_the_service']['value'])
		&& !empty(taxi::$data['langs'][abs((int)taxi::$data['site_constants']['the_language_of_the_service']['value'])])) 
	{
		define('DEFAULT_LANG', abs((int)taxi::$data['site_constants']['the_language_of_the_service']['value']));
	}
	else
	{
		define('DEFAULT_LANG', 1);
	}

	if (!empty(taxi::$data['site_constants']['currency_of_the_service']['value'])
		&& !empty(taxi::$data['currencies'][strtoupper(trim(taxi::$data['site_constants']['currency_of_the_service']['value']))]))
	{
		define('DEFAULT_CURRENCY', strtoupper(trim(taxi::$data['site_constants']['currency_of_the_service']['value'])));
	}
	else
	{
		define('DEFAULT_CURRENCY', trim('RUB'));
	}

	if (!empty(taxi::$data['site_constants']['service_country']['value'])
		&& !empty(taxi::$data['countries'][strtolower(trim(taxi::$data['site_constants']['service_country']['value']))]))
	{
		define('DEFAULT_COUNTRY', strtolower(trim(taxi::$data['site_constants']['service_country']['value'])));
	}
	else
	{
		define('DEFAULT_COUNTRY', '');
	}

	if (!empty(taxi::$data['site_constants']['service_profile']['value']))
	{
		define('DEFAULT_PROFILE', strtolower(trim(taxi::$data['site_constants']['service_profile']['value'])));
	}
	else
	{
		define('DEFAULT_PROFILE', '');
	}

    function query($s){global $link; return mysqli_query($link, $s);}
    function error_db(){global $link; return mysqli_error($link);}
    function fetch_assoc($q){return mysqli_fetch_assoc($q);}
    function insert_id(){global $link; return mysqli_insert_id($link);}
    function real_escape_string($str){global $link; return mysqli_real_escape_string($link,$str);}  
	function affected_rows(){global $link; return mysqli_affected_rows($link);}
	function num_rows($q){return mysqli_num_rows($q);}

    $link = mysqli_connect(HOST, USERNAME, PASSWORD, DBNAME) or die('Error with connection to database: ' . mysqli_connect_errno());
    query("SET NAMES 'utf8';") or die('MySQL Error: ' . error_db());

	call_user_func(function(){
		$s = "SELECT TIMEDIFF(NOW(), UTC_TIMESTAMP) as tz";
		$q = query($s);
		if ($q === false)
		{
			$_GET['route'] = 'api';
			$_GET['par'] = array('error' => 'time_zone select failed');
			require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_api.php');
		}
		$tz = fetch_assoc($q)['tz'];
		if ($tz[0] === '-')
		{
			define('MYSQL_TIME_ZONE',substr($tz,0,6));
		}
		else
		{
			define('MYSQL_TIME_ZONE','+' . substr($tz,0,5));
		}
	});
	
	query("SET group_concat_max_len = 1024*1024;");