<?php
chdir(dirname(__FILE__));
if (empty($_SERVER['DOCUMENT_ROOT'])) 
{
	$_SERVER['DOCUMENT_ROOT'] = dirname(dirname(dirname(__FILE__)));
	$_SERVER['HTTP_HOST'] = 'uticket.uventy.com';
}
define('CONFIG', 'TikShow');
require_once('config.php');
require_once('../models/m_functions.php');

while (true)
{
	$s = "SELECT
			`id_order`
		FROM `order` 
		WHERE
			 `confirm_limit_datetime` !=0 AND now() > `confirm_limit_datetime` AND `pay_datetime` = 0 AND `id_order_status` != 3
		";

	$q = query($s);
	if ($q === false) break;
	$order_succeeded = $order_failed = array();
	while ($d = fetch_assoc($q))
	{
		$cancel_status = cancel_stripe_link($d['id_order']);
		if (!empty($cancel_status['error'])) 
		{
			if (empty($cancel_status['error'][1]))
			{
				 continue;
			}
			elseif ($cancel_status['error'][1] === "Only Checkout Sessions with a status in [\"open\"] can be expired. This Checkout Session has a status of `complete`.")
			{
				$order_succeeded[] = $d['id_order'];
			}
			elseif ($cancel_status['error'][1] === "Only Checkout Sessions with a status in [\"open\"] can be expired. This Checkout Session has a status of `expired`.")
			{
				$order_failed[] = $d['id_order'];
			}
			else
			{
				continue;
			}
		}
		else
		{
			$order_failed[] = $d['id_order'];
		}
	}
	$api_use = true;
	$_GET['par'][0] = 'bot';

	$date_str = (new DateTime())->setTimezone(new DateTimeZone('+03:00'))->format('Y-m-d H:i:s+00:03');
	$log = basename(__FILE__) . ".log";

	if (!empty($order_succeeded))
	{
		require_once('../models/PHPMailer/class.smtp.php');
		require_once('../models/PHPMailer/class.phpmailer.php');
		file_put_contents($log,$date_str . ' succeeded: ' . implode(', ',$order_succeeded) . "\n",FILE_APPEND);
		$order = $order_succeeded;
		$status = 'succeeded';
		require($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_stripe.php');
	}
	if (!empty($order_failed))
	{
		require_once('../models/PHPMailer/class.smtp.php');
		require_once('../models/PHPMailer/class.phpmailer.php');
		file_put_contents($log,$date_str . ' failed: ' . implode(', ',$order_failed) . "\n",FILE_APPEND);
		$order = $order_failed;
		$status = 'failed';
		require($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_stripe.php');
	}
	file_put_contents($log,'',FILE_APPEND);
	touch($log,time(),time());
	break;
}