<?php
	header("Content-Type: text/html; charset=utf-8");
	require_once('config/config.php');
	if (ROOT_URL != '/') ini_set('session.cookie_path', ROOT_URL);
	if (UID_SUFFIX != '') session_name(session_name() . UID_SUFFIX);
	require_once('models/token.php');
	if (!empty($_SESSION[UID]) && empty($_SESSION['token_auth']))
	{
		if (!isset($_COOKIE['vfoc']) || $_COOKIE['vfoc'] != md5(session_id() . strtolower(dechex(crc32($_SESSION[UID]))))){session_unset();}
	}
	if (isset($_POST['u_a_id']) || isset($_POST['u_a_email']) || isset($_POST['u_a_phone']) || isset($_POST['u_a_tg']) || isset($_POST['u_a_wa']))
	{
		require_once('models/m_functions.php');
		check_auth_user();
		if (empty($_SESSION[UID]))
		{
			show_error('unauthorized access');
		}
		elseif ($_SESSION['id_role'] != 4)
		{
			show_error('not enough rights');
		}
		else
		{
			$AUID = get_id_user(isset($_POST['u_a_id'])?trim($_POST['u_a_id']):"",isset($_POST['u_a_email'])?trim($_POST['u_a_email']):"",isset($_POST['u_a_phone'])?trim($_POST['u_a_phone']):"",isset($_POST['u_a_tg'])?trim($_POST['u_a_tg']):"",isset($_POST['u_a_wa'])?trim($_POST['u_a_wa']):"");
			if (is_array($AUID))
			{
				show_error($AUID);
			}
			else
			{
				session_write_close();
				unset($_SESSION);
				$_SESSION[UID] = $AUID;
			}
		}
	}
	require_once('models/PHPMailer/class.smtp.php');
	require_once('models/PHPMailer/class.phpmailer.php');

	require_once('models/m_functions.php');
	if (isset($_REQUEST['lang']) && !empty(taxi::$data['langs'][$_REQUEST['lang'] = trim($_REQUEST['lang'])])) {$_SESSION['lang'] = $_REQUEST['lang'];} else {unset($_REQUEST['lang']);}

	if (isset($_GET['route']) && file_exists('controllers/c_' . $_GET['route'] . '.php')) {
		require_once('controllers/c_' . $_GET['route'] . '.php');
	} else {require_once('controllers/c_index.php');}