<?php
chdir(dirname(__FILE__));
if (empty($_SERVER['DOCUMENT_ROOT'])) $_SERVER['DOCUMENT_ROOT'] = dirname(dirname(dirname(__FILE__)));
define('CONFIG', '0');
require_once('config.php');
require_once('../models/m_functions.php');
call_user_func(function(){
	$log = basename(__FILE__) . ".log";
	preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
	$now_time = time();
	$now_datetime = gmdate("Y-m-d H:i:s",$now_time + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
	if (empty(taxi::$data['site_constants']['d_s_bot']['value']))
	{
		$s = "UPDATE `order`
			SET 
				`id_order_status` = '1',
				`process_datetime` = '" . $now_datetime . "',
				`last_edit_datetime` = '" . $now_datetime . "',
				`last_edit_user` = '0'
			WHERE
				#`id_order`.`id_order_status` in (5,6)
				`id_order`.`id_order_status` = 5
			";

		$q = query($s);
		if ($q === false)  file_put_contents($log, "$now_datetime : empty d_s_bot - database update failed\n", FILE_APPEND);
		return true;
	}
	if (empty(taxi::$data['map_places'])) file_put_contents($log, "$now_datetime : empty map_places\n", FILE_APPEND);
	$drivers_select_sorting = taxi::$data['drivers_select_sorting'];
	$constant = array(
		'average_speed'							=>	array(
													'default'	=>	60,
													'type'		=>	'non-zero unsigned integer'
												),
												
		'd_s_sorting_city'						=>	array(
													'default'	=>	array(4,3,1,2),
													'type'		=>	'list',
													'values'	=> $drivers_select_sorting
												),
		'd_s_sorting_intercity'					=>	array(
													'default'	=>	array(4,3,1,2),
													'type'		=>	'list',
													'values'	=> $drivers_select_sorting
												),												
		'd_s_distance_error_sorting'			=>	array(
													'default'	=>	1000,
													'type'		=>	'unsigned integer'
												),
		'd_s_rating_threshold_recommended'		=>	array(
													'default'	=>	80,
													'type'		=>	'non-zero unsigned integer'
												),
		'd_s_offered_drivers_count'				=>	array(
													'default'	=>	array(5,5,5),
													'type'		=>	'list'
												),											
		'rating_max_b_c'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'rating_max_b_d'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'rating_max_b_a'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'rating_max_u_c'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'rating_max_u_d'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'rating_max_u_a'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'rating_max_s_c'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'rating_max_s_d'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'rating_max_s_a'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),
		'priority_max_t'						=>	array(
													'default'	=>	5,
													'type'		=>	'non-zero unsigned integer'
												),												
		'start_select_interval'					=>	array(
													'default'	=>	array(
																		array('00:00','10:00',1200),
																		array('10:00','15:00',1800),
																		array('15:00','20:00',2100),
																		array('20:00','24:00',1500)
																	),
													'type'		=>	'json',
													'required'	=> 'all_time_keys'
												),								
		'd_s_u_location_relevance_interval'		=>	array(
													'default'	=>	60,
													'type'		=>	'unsigned integer'
												),
		'auto_cancel_time'						=>	array(
													'default'	=>	86400,
													'type'		=>	'unsigned integer'
												),
		'auto_complete_time'					=>	array(
													'default'	=>	172800,
													'type'		=>	'unsigned integer'
												),
		'd_s_offered_drivers_duration'			=>	array(
													'default'	=>	array(60,60,60),
													'type'		=>	'list'
												),
		'd_s_bot'								=>	array(
													'default'	=>	false,
													'type'		=>	'boolean'
												)
	);
	$raw_constant = !empty(taxi::$data['site_constants']) ? taxi::$data['site_constants'] : array();
	foreach($constant as $key=>$val){
		switch ($constant[$key]['type']) {
			case 'unsigned integer':
				if (isset($raw_constant[$key]['value'])) 
				{
					$constant[$key] = abs((int)$raw_constant[$key]['value']);
				}
				break;
			case 'non-zero unsigned integer':
				if (!empty($raw_constant[$key]['value'])) 
				{
					$constant[$key] = abs((int)$raw_constant[$key]['value']) ? : $constant[$key]['default'];
				}
				break;
			case 'boolean':
				if (isset($raw_constant[$key]['value'])) 
				{
					$constant[$key] = (bool)$raw_constant[$key]['value'];
				}
				break;
			case 'boolean':
				if (isset($raw_constant[$key]['value'])) 
				{
					$constant[$key] = (bool)$raw_constant[$key]['value'];
				}
				break;
			case 'list':
				if (!empty($raw_constant[$key]['value'])) 
				{
					$value = preg_replace('/\s+/','',$raw_constant[$key]['value']);
					if (preg_match('/^[0-9]+[0-9,]*$/',$value))
					{
						preg_match_all('/(?:^|,)([0-9]+)(?=,|$)/',$value,$arr,PREG_PATTERN_ORDER);
						if (!empty($arr))
						{
							if (isset($constant[$key]['values']))
							{
								foreach($arr[1] as $arr_key=>$arr_val)
								{
									$arr_val = (int)$arr_val;
									if (empty($constant[$key]['values'][$arr_val])) break 2;
									$arr[1][$arr_key] = $arr_val;
								}
							}
							else
							{				
								foreach($arr[1] as $arr_key=>$arr_val)
								{
									$arr_val = abs((int)$arr_val);
									$arr[1][$arr_key] = $arr_val;
								}
							}
							$constant[$key] = $arr[1];
						}
					}
				}
				elseif (isset($raw_constant[$key]['value']))
				{
					$constant[$key] = array();
				}
				break;		
			case 'json':
				if (!empty($constant[$key]['required'])) 
				{
					if ($constant[$key]['required'] == 'all_time_keys') 
					{
						$constant[$key] = array(
											'value' 	=> array(),
											'default'	=> $constant[$key]['default']
						);
						if (!empty($raw_constant[$key]['value']))
						{
							$json = json_decode($raw_constant[$key]['value'],true);
							if (is_array($json))
							{
								foreach($json as $interval=>$sec)
								{
									$sec = (int)$sec;
									preg_match('/^([0-9]{1,2})\:([0-9]{1,2})\s*-\s*([0-9]{1,2})\:([0-9]{1,2})$/',trim($interval),$border);
									if (!empty($border))
									{
										for($i = 1; $i < count($border); $i++)
										{
											$border[$i] = str_pad($border[$i],2,'0',STR_PAD_LEFT);
										}
										$border[1] = $border[1] . ':' . $border[2];
										$border[2] = $border[3] . ':' . $border[4];
										if ($border[1] === $border[2]) continue;
										$constant[$key]['value'][] = array($border[1],$border[2],$sec);
									}								
								}
							}
						}			
					}
				}
		}

		if (!empty($constant[$key]['type'])) $constant[$key] = $constant[$key]['default'];
	}
	unset($raw_constant);
	$places = array();
	$max_start_select_interval = 0;
	foreach(taxi::$data['map_places'] as $id=>$place)
	{
		preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',$place['timezone'],$parsed_time_zone);
		$h = gmdate("H:i",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
		foreach($constant['start_select_interval']['value'] as $values)
		{
			if ($values[1] > $values[0])
			{
				if ($h < $values[0] || $h >= $values[1]) continue; //!($h >= $values[0] && $h < $values[1])
			}
			else
			{
				if ($h < $values[0] && $h >= $values[1]) continue; //!($h >= $values[0] || $h < $values[1])
			}
			$places[$id] = $place;
			$places[$id]['start_select_interval'] = $values[2];
			if ($values[2] > $max_start_select_interval) $max_start_select_interval = $values[2];
			continue 2;
		}
		foreach($constant['start_select_interval']['default'] as $values)
		{
			if ($h >= $values[0] && $h < $values[1])
			{
				$places[$id] = $place;
				$places[$id]['start_select_interval'] = $values[2];
				if ($values[2] > $max_start_select_interval) $max_start_select_interval = $values[2];
				continue 2;
			}
		}
	}
	if (empty($places)) file_put_contents($log, "$now_datetime : empty places\n", FILE_APPEND);
	$max_arr_len = max(count($constant['d_s_offered_drivers_count']),count($constant['d_s_offered_drivers_duration']));
	if (empty($max_arr_len))
	{
		$s = "UPDATE `order`
			SET 
				`id_order_status` = '1',
				`process_datetime` = '" . $now_datetime . "',
				`last_edit_datetime` = '" . $now_datetime . "',
				`last_edit_user` = '0'
			WHERE
				`id_order`.`id_order_status` in (5,6)
			";

		$q = query($s);
		if ($q === false) file_put_contents($log, "$now_datetime : empty max_arr_len - database update failed\n", FILE_APPEND);
		return true;
	}
	$constant['d_s_offered_drivers_count_duration'] = array();
	$i = 0;
	for(; $i < $max_arr_len; $i++)
	{
		if (!isset($constant['d_s_offered_drivers_count'][$i]))
		{
			$drivers_count = 'all';
			$i = $max_arr_len;
		}
		else
		{
			$drivers_count = $constant['d_s_offered_drivers_count'][$i];
		}
		if (!isset($constant['d_s_offered_drivers_duration'][$i]))
		{
			$drivers_duration = 'infinity';
			$i = $max_arr_len;
		} 
		else
		{
			$drivers_duration = $constant['d_s_offered_drivers_duration'][$i];
		}
		$constant['d_s_offered_drivers_count_duration'][] = array($drivers_count,$drivers_duration);
	}
	if ($i === $max_arr_len) 
	{
		$constant['d_s_offered_drivers_count_duration'][] = array('all','infinity');
	}
	else
	{
		if ($constant['d_s_offered_drivers_count_duration'][count($constant['d_s_offered_drivers_count_duration'])-1][0] == 'all') 
		{
			$constant['d_s_offered_drivers_count_duration'][] = 'cancel';
			if ($i == 2)
			{		
				$s = "UPDATE `order`
					SET 
						`id_order_status` = '1',
						`process_datetime` = '" . $now_datetime . "',
						`last_edit_datetime` = '" . $now_datetime . "',
						`last_edit_user` = '0'
					WHERE
						`id_order`.`id_order_status` in (5,6)
					";

				$q = query($s);
				if ($q === false) file_put_contents($log, "$now_datetime : max_arr_len=1 - database update to processing failed\n", FILE_APPEND);
				
				
				$s = "UPDATE `order`
					SET 
						`id_order_status` = '3',
						`cancel_datetime` = '" . $now_datetime . "',
						`last_edit_datetime` = '" . $now_datetime . "',
						`last_edit_user` = '0'
					WHERE
						`id_order` = '1' AND 
						process_datetime <= now() - INTERVAL '" . $constant['d_s_offered_drivers_count_duration'][0][1] . "' SECOND
					";

				$q = query($s);
				if ($q === false) file_put_contents($log, "$now_datetime : max_arr_len=1 - database update to canceled failed\n", FILE_APPEND);		
				return true;	
			}
			else
			{
				$s = "UPDATE `order`
					SET 
						`id_order_status` = '3',
						`cancel_datetime` = '" . $now_datetime . "',
						`last_edit_datetime` = '" . $now_datetime . "',
						`last_edit_user` = '0'
					WHERE
						`id_order` = '1' AND 
						process_datetime <= now() - INTERVAL '" . $constant['d_s_offered_drivers_count_duration'][count($constant['d_s_offered_drivers_count_duration'])-2][1] . "' SECOND
					";

				$q = query($s);
				if ($q === false) file_put_contents($log, "$now_datetime : max_arr_len>1 - database update to canceled failed\n", FILE_APPEND);	
			}
		}
	}
	$sql_where_code = "";//" AND `order`.`code` = ''";

	$s = "SELECT
			`order`.`id_order`,
			`order`.`id_order_status`,
			`order`.`from`,
			`order`.`from_lat`,
			`order`.`from_lng`,
			TIMESTAMPDIFF(SECOND,NOW(),`order`.`datetime_start_plan`) as start_interval,
			`order`.`id_car_class`,
			GROUP_CONCAT(`users_favorite`.`id_favorite` SEPARATOR ',') as favorite,
			`order`.`create_datetime`,
			`order`.`car_count`
		FROM `order` 
		LEFT JOIN `users_favorite` ON `users_favorite`.`id_user` = `order`.`client`
		WHERE	
			`order`.`id_order_status` = '5'" . $sql_where_code . " AND `order`.`datetime_start_plan` AND `order`.`datetime_start_plan`<= now() + INTERVAL '" . $max_start_select_interval . "' SECOND
		GROUP BY 
			`order`.`id_order`
		";

	$q = query($s);

	if ($q === false) file_put_contents($log, "$now_datetime : database pending select failed\n", FILE_APPEND);

	$order_for_select = array();
	$order_for_offer = array();
	$order_for_process = array();	
	$order_for_cancel = array();
	$order_loc = array();

	while (@$d = fetch_assoc($q))
	{
		if (!isset($d['from_lat']) || !isset($d['from_lng']))
		{
			list($d['from_lat'],$d['from_lng']) = address_to_lat_lng($d['from']);
		}
		if (isset($d['from_lat']) && isset($d['from_lng']))
		{		
			foreach($places as $id=>$place)
			{
				if ($d['from_lng'] >= $place['min_lng'] && $d['from_lng'] <= $place['max_lng'] 
					&& $d['from_lat'] >= $place['min_lat'] && $d['from_lat'] <= $place['max_lat'])
				{
					if ($d['start_interval'] <= $place['start_select_interval'])
					{
						$d['place'] = $id;
						$d['start_select_interval'] = $place['start_select_interval'];
					}
					break;
				}
			}
			if (!empty($d['place']))
			{
				$d['create_datetime'] = strtotime($d['create_datetime'] . MYSQL_TIME_ZONE);
				$d['from_square'] = lat_lng_to_square($d['from_lat'],$d['from_lng'],$places[$d['place']]);
				$d['current_driver_count'] = $constant['d_s_offered_drivers_count_duration'][0][0];
				$order_for_select[$d['id_order']] = $d;
				$order_for_offer[] = $d['id_order'];			
			}			
		}	
	}

	$s = "SELECT
			`order`.`id_order`,
			`order`.`id_order_status`,
			`order`.`from`,
			`order`.`from_lat`,
			`order`.`from_lng`,
			`order`.`id_car_class`,
			(SELECT
				GROUP_CONCAT(`users_favorite`.`id_favorite` SEPARATOR ',')
			 FROM `users_favorite`
			 WHERE `users_favorite`.`id_user` = `order`.`client`
			) as  favorite,
			(SELECT
				CONCAT_WS('|',CAST(COUNT(`order_offer`.`id_order`) as char),CAST(MAX(`order_offer`.`create_datetime`) as datetime))
			 FROM `order_offer`
			 WHERE `order_offer`.`id_order` = `order`.`id_order`
			) as offer,			
			COUNT(IF(`order_driver_select`.`cancel` = '0',1,NULL)) as uncancelled_drivers,
			GROUP_CONCAT(`order_driver_select`.`id_user` SEPARATOR ',') as already_selected,
			TIMESTAMPDIFF(SECOND,NOW(),`order`.`datetime_start_plan`) as start_interval,
			`order`.`create_datetime`,
			`order`.`car_count`
		FROM `order` 
		LEFT JOIN `order_driver_select` USING (`id_order`)	
		WHERE	
			`order`.`id_order_status` = '6' AND `order`.`datetime_start_plan`
		GROUP BY 
			`order`.`id_order`
		";

	$q = query($s);

	if ($q === false) file_put_contents($log, "$now_datetime : database offered select failed\n", FILE_APPEND);

	while (@$d = fetch_assoc($q))
	{
		$d['create_datetime'] = strtotime($d['create_datetime'] . MYSQL_TIME_ZONE);
		$d['offer'] = explode('|',$d['offer']);
		$offer_count = (int)$d['offer'][0];
		$offer_last_date = strtotime($d['offer'][1] . MYSQL_TIME_ZONE);
		if (isset($constant['d_s_offered_drivers_count_duration'][$offer_count]))
		{
			$offer_count_limit = false;
			$current_driver_count = $constant['d_s_offered_drivers_count_duration'][$offer_count][0];			
		}
		else
		{
			$offer_count_limit = true;
			$offer_count = count($constant['d_s_offered_drivers_count_duration']) - 1;
			$current_driver_count =  $constant['d_s_offered_drivers_count_duration'][$offer_count][0];
		}
		if ($constant['d_s_offered_drivers_count_duration'][$offer_count] === 'cancel')
		{
			if ($offer_count_limit === true || $now_time >= $offer_last_date + $constant['d_s_offered_drivers_count_duration'][$offer_count-1][1])
			{
				$order_for_cancel[] = $d['id_order'];
			}
			else
			{
				$order_for_process[] = $d['id_order'];
			}	
		}
		else
		{
			if ($current_driver_count === 'all')
			{
				if ($offer_count_limit === true || $now_time >= $offer_last_date + $constant['d_s_offered_drivers_count_duration'][$offer_count-1][1] || empty($d['uncancelled_drivers']))
				{
					$order_for_process[] = $d['id_order'];
				}		
			}
			else
			{
				if (!(
					($offer_count_limit === false && $constant['d_s_offered_drivers_count_duration'][$offer_count-1][1] === 'infinity') 
					||
					($offer_count_limit === true && $constant['d_s_offered_drivers_count_duration'][$offer_count][1] === 'infinity')
					))
				{
					if ($offer_count_limit === false && (empty($d['uncancelled_drivers']) || $now_time >= $offer_last_date + $constant['d_s_offered_drivers_count_duration'][$offer_count-1][1]))
					{
						if (!isset($d['from_lat']) || !isset($d['from_lng']))
						{
							list($d['from_lat'],$d['from_lng']) = address_to_lat_lng($d['from']);
						}
						if (isset($d['from_lat']) && isset($d['from_lng']))
						{			
							foreach($places as $id=>$place)
							{
								if ($d['from_lng'] >= $place['min_lng'] && $d['from_lng'] <= $place['max_lng'] 
									&& $d['from_lat'] >= $place['min_lat'] && $d['from_lat'] <= $place['max_lat'])
								{
									$d['place'] = $id;
									break;
								}
							}
							if (!empty($d['place']))
							{
								$d['from_square'] = lat_lng_to_square($d['from_lat'],$d['from_lng'],$places[$d['place']]);
								$d['current_driver_count'] = $current_driver_count;
								$already_selected = explode(',',$d['already_selected']);
								$d['already_selected'] = array();
								foreach($already_selected as $id_user)
								{
									$d['already_selected'][$id_user] = true;
								}
								$order_for_select[$d['id_order']] = $d;	
							}			
						}
					}
				}
			}
		}
	}

	$drivers = array();
	if (!empty($order_for_select))
	{
		$loc_sec = $constant['d_s_u_location_relevance_interval'];
		if (empty($loc_sec))
		{
			$sql_where_loc = "";
		}
		else
		{
			$sql_where_loc = "`users_location`.`datetime` > NOW() - INTERVAL '" . $loc_sec . "' SECOND AND";
		}
		$sql_where_car_users = "";//"AND `car_users`.`used` = '1'";
		$s = "SELECT 
				`users`.`id_user`,
				`users`.`referrer`,
				`users`.`max_s_rating`,
				`users`.`s_rating`,
				`users`.`u_max_rating`,
				`users`.`u_rating`,			
				`users_location`.`lat`,
				`users_location`.`lng`,
				`car`.`id_car_class`
			FROM `users`
			LEFT JOIN `users_location` USING (`id_user`)
			LEFT JOIN `car_users` USING (`id_user`)
			LEFT JOIN `car` ON `car`.`id_car` = `car_users`.`id_car`
			WHERE
				`id_role` = '2' AND `id_verification_status` = '2' AND `deleted` = '0' AND `active` = '1' AND
				`out_order` = '0' AND 
				" . $sql_where_loc . "
				`users_location`.`lat` IS NOT NULL AND `users_location`.`lng` IS NOT NULL AND 
				(
					SELECT 
						`id_user`
					FROM `users_ban`
					WHERE
						`users_ban`.`id_user` = `users`.`id_user` AND (`expire_datetime` = 0 OR `expire_datetime` > NOW()) AND
						(`auth` = '1' OR `order` = '1')
					LIMIT 1
				) IS NULL AND
				(
					SELECT 
						`order`.`id_order`				
					FROM `order`
					LEFT JOIN `order_driver` USING (`id_order`)
					LEFT JOIN `order_driver_select` USING (`id_order`)
					WHERE
						`order`.`id_order_status` in (1,2,6) AND 
						(
							`order`.`datetime_start_plan` = 0 OR 
							`order`.`datetime_start_plan` > now() - INTERVAL '86400' SECOND
						)
						AND 
						(
							(
								`order_driver`.`id_user` = `users`.`id_user` AND 
								`order_driver`.`id_order_driver_status` in (3,4,5)
							)
							OR
							(
								`order_driver_select`.`id_user` = `users`.`id_user` AND 
								`order_driver_select`.`cancel` = '0'
							)
						)
					LIMIT 1
				) IS NULL " . $sql_where_car_users . "
			GROUP BY 
				`users`.`id_user`
			";

		$q = query($s);

		if ($q === false) file_put_contents($log, "$now_datetime : user database select failed\n", FILE_APPEND);
		
		$users = array();
		$users_loc = array();

		while (@$d = fetch_assoc($q))
		{
			foreach($places as $id=>$place)
			{
				if ($d['lng'] >= $place['min_lng'] && $d['lng'] <= $place['max_lng'] 
					&& $d['lat'] >= $place['min_lat'] && $d['lat'] <= $place['max_lat'])
				{
					$d['place'] = $id;
					break;
				}
			}
			if (!empty($d['place']))
			{
				$d['square'] = lat_lng_to_square($d['lat'],$d['lng'],$places[$d['place']]);
				$d['orders_sel_by_par'] = array();
				$users[$d['id_user']] = $d;	
				$users_loc[$d['place']][$d['id_car_class']][$d['id_user']] = $d['square'];
			}
		}

		$loc = array();
		if (!empty($users_loc))
		{
			foreach($order_for_select as $id_order=>$order)
			{
				$order_for_select[$id_order]['drivers_sel_by_par'] = array();
				if (empty($order_for_select[$id_order]['current_driver_count'])) continue;
				if (isset($users_loc[$order['place']]))
				{
					if (empty($order['id_car_class'])) 
					{
						foreach($users_loc[$order['place']] as $user_square)
						{
							foreach($user_square as $id_user=>$square)
							{
								if (!empty($order_for_select[$id_order]['already_selected'][$id_user]))
								{
									continue;
								}
								if (($square == $order['from_square']))
								{
									$order_for_select[$id_order]['drivers_sel_by_par'][$id_user] = 0;
									$users[$id_user]['orders_sel_by_par'][$id_order] = 0;
								}
								else
								{
									$loc[$order['place']][$square][$order['from_square']] = true;

									$order_for_select[$id_order]['drivers_sel_by_par'][$id_user] = true;

									$users[$id_user]['orders_sel_by_par'][$id_order] = true;
								}
							}				
						}
					}
					elseif (isset($users_loc[$order['place']][$order['id_car_class']]))
					{
						foreach($users_loc[$order['place']][$order['id_car_class']] as $id_user=>$square)
						{
							if (!empty($order_for_select[$id_order]['already_selected'][$id_user]))
							{
								continue;
							}
							if (($square == $order['from_square']))
							{
								$order_for_select[$id_order]['drivers_sel_by_par'][$id_user] = 0;
								$users[$id_user]['orders_sel_by_par'][$id_order] = 0;
							}
							else
							{
								$loc[$order['place']][$square][$order['from_square']] = true;
								$order_for_select[$id_order]['drivers_sel_by_par'][$id_user] = true;
								$users[$id_user]['orders_sel_by_par'][$id_order] = true;
							}
						}				
					}
				}
			}

			$loc = get_time_distance($loc,$constant['average_speed']);
			if ($loc === false) file_put_contents($log, "$now_datetime : map_distance database select failed\n", FILE_APPEND);

			$order_for_select_list = array();
			foreach($order_for_select as $id_order=>$order)
			{
				foreach($order['drivers_sel_by_par'] as $id_user=>$val)
				{
					if ($val === true)
					{
						if (isset($loc[$order['place']][$users[$id_user]['square']][$order['from_square']]))
						{
							$order_for_select[$id_order]['drivers_sel_by_par'][$id_user] = $loc[$order['place']][$users[$id_user]['square']][$order['from_square']];
						}
						else
						{
							unset($order_for_select[$id_order]['drivers_sel_by_par'][$id_user]);
							unset($users[$id_user]['orders_sel_by_par'][$id_order]);
							continue;
						}
					}

					if ($order_for_select[$id_order]['drivers_sel_by_par'][$id_user] > $order['start_interval'])
					{
						unset($order_for_select[$id_order]['drivers_sel_by_par'][$id_user]);
						unset($users[$id_user]['orders_sel_by_par'][$id_order]);
					}
				}
				if (count($order_for_select[$id_order]['drivers_sel_by_par'])) $order_for_select_list[] = $id_order;
//				asort($order_for_select[$id_order]['drivers_sel_by_par']);
			}

			while (count($order_for_select_list))
			{
				usort(
					$order_for_select_list,
					function ($id1, $id2) use ($order_for_select)
					{
						$flag1 = count($order_for_select[$id1]['drivers_sel_by_par']);
						$flag2 = count($order_for_select[$id2]['drivers_sel_by_par']);
						if ($flag1 > $flag2) 
						{
							return 1;
						}
						elseif ($flag1 < $flag2)
						{
							return -1;
						}
						else
						{
							$flag1 = empty($order_for_select[$id1]['uncancelled_drivers']) ? 0 : 1;
							$flag2 = empty($order_for_select[$id2]['uncancelled_drivers']) ? 0 : 1;
							if ($flag1 > $flag2) 
							{
								return 1;
							}
							elseif ($flag1 < $flag2)
							{
								return -1;
							}
							else
							{
								$flag1 = $order_for_select[$id1]['create_datetime'];
								$flag2 = $order_for_select[$id2]['create_datetime'];
								if ($flag1 > $flag2) 
								{
									return 1;
								}
								elseif ($flag1 < $flag2)
								{
									return -1;
								}
								else
								{
									$flag1 = $order_for_select[$id1]['start_interval'];
									$flag2 = $order_for_select[$id2]['start_interval'];
									if ($flag1 > $flag2) 
									{
										return 1;
									}
									elseif ($flag1 < $flag2)
									{
										return -1;
									}
									return 0;	
								}
							}
						}
					}
				);

				foreach($order_for_select_list as $key=>$id_order)
				{
					uksort(
						$order_for_select[$id_order]['drivers_sel_by_par'],
						function ($id1, $id2) use ($users,$id_order,$order_for_select)
						{
							$flag1 = count($users[$id1]['orders_sel_by_par'][$id_order]);
							$flag2 = count($users[$id2]['orders_sel_by_par'][$id_order]);
							if ($flag1 > $flag2) 
							{
								return 1;
							}
							elseif ($flag1 < $flag2)
							{
								return -1;
							}
							else
							{
								$flag1 = $order_for_select[$id_order]['drivers_sel_by_par'][$id1];
								$flag2 = $order_for_select[$id_order]['drivers_sel_by_par'][$id2];
								if ($flag1 > $flag2) 
								{
									return 1;
								}
								elseif ($flag1 < $flag2)
								{
									return -1;
								}
								return 0;				
							}
						}
					);
					
					$cycle = false;
					$add_check = true;
					do {
						foreach($order_for_select[$id_order]['drivers_sel_by_par'] as $id_user=>$val)
						{
							if (isset($users[$id_user]['orders_sel_by_par']))
							{
								if ($add_check === true)
								{	
									$o_count = 0;
									$id_u_arr = array();
									$u_count = 0;
									foreach($users[$id_user]['orders_sel_by_par'] as $id_o=>$v_o)
									{
										if ($id_o !== $id_order)
										{
											$o_count++;
											foreach($order_for_select[$id_o]['drivers_sel_by_par'] as $id_u=>$v_u)
											{
												if (empty($id_u_arr[$id_u]))
												{
													$id_u_arr[$id_u] = true;
													$u_count++;
												}
											}
										}		
									}
									if ($o_count >= $u_count)
									{
										$user_need_for_other_order = true;
									}
									else
									{
										$user_need_for_other_order = false;
									}
									if ($user_need_for_other_order)
									{
										$cycle = true;
										continue;
									}
								}
								$drivers[$id_order][] = $id_user;
								unset($order_for_select[$id_order]['drivers_sel_by_par'][$id_user]);
								unset($users[$id_user]['orders_sel_by_par']);
								break 2;
							}
							else
							{
								unset($order_for_select[$id_order]['drivers_sel_by_par'][$id_user]);
							}					
						}
						$add_check = false;
					} while ($cycle);

					if (count($order_for_select[$id_order]['drivers_sel_by_par']) == 0
						|| count($drivers[$id_order]) == $order_for_select[$id_order]['current_driver_count'])
					{
						unset($order_for_select_list[$key]);			
					}
				}		
			}
		}
	}

	if (!empty($order_for_offer))
	{
		$s = "UPDATE `order`
			SET 
				`id_order_status` = '6',
				`offer_datetime` = '" . $now_datetime . "',
				`last_edit_datetime` = '" . $now_datetime . "',
				`last_edit_user` = '0'
			WHERE
				`id_order` in (" . implode(",", $order_for_offer) . ")
			";

		$q = query($s);
		if ($q === false) file_put_contents($log, "$now_datetime : array order_for_offer - database update failed\n", FILE_APPEND);	
	}

	if (!empty($order_for_process))
	{
		$s = "UPDATE `order`
			SET 
				`id_order_status` = '1',
				`process_datetime` = '" . $now_datetime . "',
				`last_edit_datetime` = '" . $now_datetime . "',
				`last_edit_user` = '0'
			WHERE
				`id_order` in (" . implode(",", $order_for_process) . ")
			";

		$q = query($s);
		if ($q === false) file_put_contents($log, "$now_datetime : array order_for_process - database update failed\n", FILE_APPEND);
	}

	if (!empty($order_for_cancel))
	{
		$s = "UPDATE `order`
			SET 
				`id_order_status` = '3',
				`cancel_datetime` = '" . $now_datetime . "',
				`last_edit_datetime` = '" . $now_datetime . "',
				`last_edit_user` = '0'
			WHERE
				`id_order` in (" . implode(",", $order_for_cancel) . ")
			";

		$q = query($s);
		if ($q === false) file_put_contents($log, "$now_datetime : array order_for_cancel - database update failed\n", FILE_APPEND);
	}

	if (!empty($order_for_select))
	{
		$s = array();
		foreach($order_for_select as $id_order=>$order)
		{
			$s[] = "('" . $id_order . "', '" . $now_datetime . "')";
		}
		$s = "INSERT INTO `order_offer` (`id_order`,`create_datetime`) VALUES " . implode(",", $s);
		$q = query($s);
		if ($q === false) file_put_contents($log, "$now_datetime : array order_for_select - database insert failed\n", FILE_APPEND);
	}

	if (!empty($drivers))
	{
		$s = array();
		foreach($drivers as $id_order=>$user_list)
		{
			foreach($user_list as $id_user)
			{
				$s[] = "('" . $id_order . "', '" . $id_user . "', '" . $now_datetime . "')";
			}
		}
		$s = "INSERT INTO `order_driver_select` (`id_order`,`id_user`,`create_datetime`) VALUES " . implode(",", $s);
		$q = query($s);
		if ($q === false) file_put_contents($log, "$now_datetime : array drivers - database insert failed\n", FILE_APPEND);
	}
});