<?php
	require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'models/api.php');
	$out = array();header('Access-Control-Allow-Origin: *');
	$API = new API(!empty(taxi::$data['site_constants']) ? taxi::$data['site_constants'] : array(),!empty(taxi::$data['car_classes']) ? taxi::$data['car_classes'] : array());
	
	if (isset($_GET['par']['error'])) 
	{
		$out = $API->showError('404', 'error', $_GET['par']['error']);
	}
	else
	{
		if (isset($_REQUEST['array_type']) && trim($_REQUEST['array_type']) == 'list')
		{
			$API->associativeArray = false;
		}
		$API->tuneLimit(isset($_REQUEST['lo'])?$_REQUEST['lo']:NULL,isset($_REQUEST['lc'])?$_REQUEST['lc']:NULL);
		if (isset($_REQUEST['appUrl']))
		{
			$API->appUrl = $_REQUEST['appUrl'];
		}

		if (isset($_GET['par'][1]))
		{
			if ($_GET['par'][1] == 'register')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				$out = $API->registerUser(isset($_POST['u_role'])?trim($_POST['u_role']):'',isset($_POST['u_phone'])?trim($_POST['u_phone']):'',isset($_POST['u_email'])?trim($_POST['u_email']):'',isset($_POST['u_tg'])?trim($_POST['u_tg']):'',isset($_POST['u_wa'])?trim($_POST['u_wa']):'',isset($_POST['u_name'])?trim($_POST['u_name']):'',isset($_POST['ref_code'])?trim($_POST['ref_code']):'',isset($_COOKIE['reco'])?trim($_COOKIE['reco']):'',$_SERVER['REMOTE_ADDR'],isset($_POST['data'])?$_POST['data']:'',isset($_POST['st'])?true:false,isset(taxi::$data['user_roles'])?taxi::$data['user_roles']:array());
			}
			elseif ($_GET['par'][1] == 'auth')
			{
				$out = $API->authUser(isset($_POST['login'])?trim($_POST['login']):'',isset($_POST['password'])?trim($_POST['password']):'',isset($_POST['type'])?trim($_POST['type']):'');

			}
			elseif ($_GET['par'][1] == 'logout')
			{
				$out = $API->logout();
			}
			elseif ($_GET['par'][1] == 'remind')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				$out = $API->remind(isset($_POST['u_email'])?trim($_POST['u_email']):'',isset($_POST['u_phone'])?trim($_POST['u_phone']):'',isset($_POST['u_tg'])?trim($_POST['u_tg']):'',isset($_POST['u_wa'])?trim($_POST['u_wa']):'');
			}
			elseif ($_GET['par'][1] == 'newpass')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				$out = $API->newpass(isset($_POST['password'])?trim($_POST['password']):'',isset($_POST['new_password'])?trim($_POST['new_password']):'');
			}
			elseif ($_GET['par'][1] == 'user')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (empty($_GET['par'][3]))
				{
					if (isset($_POST['data']))
					{
						$out = $API->editUser($_POST['data'],isset($_GET['par'][2])?trim($_GET['par'][2]):'',isset(taxi::$data['user_roles'])?taxi::$data['user_roles']:array());
					}
					else
					{
						$out = $API->selectUser(isset($_GET['par'][2])? trim($_GET['par'][2]):'');
					}
				}
				elseif ($_GET['par'][3] == 'car')
				{
					if (isset($_POST['data']))
					{
						$out = $API->controlCar($_POST['data'],isset($_GET['par'][4])?trim($_GET['par'][4]):'',isset($_GET['par'][2])?trim($_GET['par'][2]):'',isset(taxi::$data['langs'])?taxi::$data['langs']:array(),isset(taxi::$data['booking_location_classes'])?taxi::$data['booking_location_classes']:array(),isset(taxi::$data['currencies'])?taxi::$data['currencies']:array(),isset(taxi::$data['countries'])?taxi::$data['countries']:array(),isset(taxi::$data['regions'])?taxi::$data['regions']:array(),isset(taxi::$data['cities'])?taxi::$data['cities']:array());
					}
					else
					{
						$out = $API->selectCar(isset($_GET['par'][4])?trim($_GET['par'][4]):'',isset($_GET['par'][2])?trim($_GET['par'][2]):'',isset(taxi::$data['langs'])?taxi::$data['langs']:array());
					}
				}
				elseif ($_GET['par'][3] == 'favorite')
				{
					if (empty($_GET['par'][5]))
					{
						$out = $API->selectFavoriteUser(trim($_GET['par'][2]));
					}
					elseif ($_GET['par'][5] == 'add')
					{
						$out = $API->addFavoriteUser(trim($_GET['par'][2]),trim($_GET['par'][4]));
					}
					elseif ($_GET['par'][5] == 'remove')
					{
						$out = $API->removeFavoriteUser(trim($_GET['par'][2]),trim($_GET['par'][4]));
					}
				}
				elseif ($_GET['par'][3] == 'referral')
				{
					if (empty($_GET['par'][4]))
					{
						$out = $API->selectReferralUser(trim($_GET['par'][2]));
					}
					else
					{
						if ($_GET['par'][4] == 'link')
						{
							$out = $API->selectReferralUrl(trim($_GET['par'][2]));
						}
					}
				}
				elseif ($_GET['par'][3] == 'inner')
				{
					if (empty($_GET['par'][4]))
					{
						$out = $API->selectInnerUser(trim($_GET['par'][2]));
					}
				}
			}
			elseif ($_GET['par'][1] == 'car')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (empty($_GET['par'][3]))
				{
					if (isset($_POST['data']))
					{
						$out = $API->controlCar($_POST['data'],isset($_GET['par'][2])?trim($_GET['par'][2]):'','',isset(taxi::$data['langs'])?taxi::$data['langs']:array(),isset(taxi::$data['booking_location_classes'])?taxi::$data['booking_location_classes']:array(),isset(taxi::$data['currencies'])?taxi::$data['currencies']:array(),isset(taxi::$data['countries'])?taxi::$data['countries']:array(),isset(taxi::$data['regions'])?taxi::$data['regions']:array(),isset(taxi::$data['cities'])?taxi::$data['cities']:array());
					}
					else
					{
						$out = $API->selectCar(isset($_GET['par'][2])?trim($_GET['par'][2]):'','',isset(taxi::$data['langs'])?taxi::$data['langs']:array());
					}
				}
				elseif ($_GET['par'][3] == 'drive')
				{
					$out = $API->setCarUsed(trim($_GET['par'][2]));
				}
			}
			elseif ($_GET['par'][1] == 'cache' 
				&& !empty($_GET['par'][2]) && $_GET['par'][2] == 'update' && !(empty($_POST['hash'])))
			{
				$out = $API->updateCache(trim($_POST['hash']));
			}
			elseif ($_GET['par'][1] == 'drive')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (empty($_GET['par'][2]))
				{
					if (isset($_POST['data']))
					{
						$out = $API->createOrder($_POST['data'],isset(taxi::$data['langs'])?taxi::$data['langs']:array(),isset(taxi::$data['payment_ways'])?taxi::$data['payment_ways']:array(),isset(taxi::$data['payment_card'])?taxi::$data['payment_card']:array(),isset(taxi::$data['booking_comments'])?taxi::$data['booking_comments']:array(),isset(taxi::$data['services'])?taxi::$data['services']:array(),isset(taxi::$data['contact_classes'])?taxi::$data['contact_classes']:array(),isset(taxi::$data['booking_location_classes'])?taxi::$data['booking_location_classes']:array(),isset(taxi::$data['currencies'])?taxi::$data['currencies']:array(),isset(taxi::$data['unit_sets'])?taxi::$data['unit_sets']:array(),isset(taxi::$data['countries'])?taxi::$data['countries']:array(),isset(taxi::$data['regions'])?taxi::$data['regions']:array(),isset(taxi::$data['cities'])?taxi::$data['cities']:array(),isset(taxi::$data_sc['schedule'])?taxi::$data_sc['schedule']:array(),isset(taxi::$data_private['price_time_functions'])?taxi::$data_private['price_time_functions']:array(),empty(taxi::$data['site_constants']['stripe_seat_title_template'])?'':taxi::$data['site_constants']['stripe_seat_title_template']['value'],empty(taxi::$data['site_constants']['stripe_request_duration'])?0:taxi::$data['site_constants']['stripe_request_duration']['value']);
					}
					else
					{
						$out = $API->selectActiveOrder(isset($_REQUEST['fields'])?$_REQUEST['fields']:0);
					}
				}
				else
				{
					if ($_GET['par'][2] == 'get')
					{
						if (isset($_POST['action']))
						{
							if (!empty($_GET['par'][3]))
							{
								if ($_POST['action'] == 'set_confirm_state')
								{
									$out = $API->confirmOrder(trim($_GET['par'][3]),isset($_POST['b_estimate_waiting'])?trim($_POST['b_estimate_waiting']):NULL);
								}
								if ($_POST['action'] == 'set_waiting_time')
								{
									$out = $API->editWaitingTime(trim($_GET['par'][3]),isset($_POST['previous'])?trim($_POST['previous']):NULL,isset($_POST['additional'])?trim($_POST['additional']):NULL);
								}
								if ($_POST['action'] == 'set_performer')
								{
									$out = $API->setDriver(isset($_POST['data'])?$_POST['data']:'',trim($_GET['par'][3]),!empty($_POST['u_id'])?trim($_POST['u_id']):'',empty($_POST['performer'])?0:1,isset($_POST['b_driver_code'])?trim($_POST['b_driver_code']):NULL,isset($_POST['t_id'])?trim($_POST['t_id']):'');
								}
								elseif ($_POST['action'] == 'set_arrive_state')
								{
									$out = $API->setCarIsArrived(trim($_GET['par'][3]));
								}
								elseif ($_POST['action'] == 'set_start_state')
								{
									$out = $API->startOrder(trim($_GET['par'][3]));
								}
								elseif ($_POST['action'] == 'set_complete_state')
								{
									$out = $API->completeOrder(trim($_GET['par'][3]));
								}
								elseif ($_POST['action'] == 'set_cancel_state')
								{
									$out = $API->cancelOrder(trim($_GET['par'][3]),isset($_REQUEST['forced'])?trim($_REQUEST['forced']):0,isset($_POST['reason'])?trim($_POST['reason']):'',isset($_POST['cancel_states'])?trim($_POST['cancel_states']):'',isset(taxi::$data['booking_cancel_states'])?taxi::$data['booking_cancel_states']:array());	
								}
								elseif ($_POST['action'] == 'set_rate' && isset($_POST['value']))
								{
									$out = $API->rateOrder(trim($_GET['par'][3]),trim($_POST['value']));
								}
								elseif ($_POST['action'] == 'edit')
								{
									$out = $API->editOrder(isset($_POST['data'])?$_POST['data']:'',trim($_GET['par'][3]));
								}
								elseif ($_POST['action'] == 'set_tips')
								{
									$out = $API->setOrderTips(trim($_GET['par'][3]),isset($_POST['b_tips'])?trim($_POST['b_tips']):NULL,isset($_POST['c_tips'])?trim($_POST['c_tips']):NULL);
								}						
								elseif ($_POST['action'] == 'set_offer')
								{
									$out = $API->offerOrder(trim($_GET['par'][3]),isset($_POST['u_id'])?trim($_POST['u_id']):'',isset($_POST['t_id'])?trim($_POST['t_id']):'');
								}
							}
						}
						else
						{
							$out = $API->selectOrder(isset($_GET['par'][3])?trim($_GET['par'][3]):'',isset($_REQUEST['fields'])?$_REQUEST['fields']:0);
						}
					}
					elseif ($_GET['par'][2] == 'now')
					{
						$out = $API->selectProcessingOrder(isset($_REQUEST['fields'])?$_REQUEST['fields']:0,isset($_REQUEST['filter'])?$_REQUEST['filter']:NULL,isset(taxi::$data['booking_location_classes'])?taxi::$data['booking_location_classes']:array());
					}
					elseif ($_GET['par'][2] == 'archive')
					{
						$out = $API->selectArchiveOrder(isset($_REQUEST['fields'])?$_REQUEST['fields']:0);
					}
				}
			}
			elseif ($_GET['par'][1] == 'trip')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (empty($_GET['par'][2]))
				{
					if (isset($_POST['data']))
					{
						$out = $API->createTrip(empty($_POST['u_id'])?'':trim($_POST['u_id']),$_POST['data'],isset(taxi::$data['langs'])?taxi::$data['langs']:array(),DEFAULT_PROFILE == 'stadium' ? array(taxi::$data,taxi::$data_stt,taxi::$data_sc) : array());
					}
					else
					{
						$out = $API->selectTrip(NULL,'active',isset($_REQUEST['orders'])?trim($_REQUEST['orders']):"",isset($_REQUEST['filter'])?$_REQUEST['filter']:NULL,isset($_REQUEST['fields'])?$_REQUEST['fields']:0,isset(taxi::$data_private['price_time_functions'])?taxi::$data_private['price_time_functions']:array());
					}
				}
				
				else
				{
					if ($_GET['par'][2] == 'get')
					{
						if (empty($_GET['par'][4]))
						{
							if (isset($_POST['action']))
							{
								if (!empty($_GET['par'][3]))
								{
									if ($_POST['action'] == 'edit')
									{
										$out = $API->editTrip(isset($_POST['data'])?$_POST['data']:'',trim($_GET['par'][3]));
									}
								}
							}
							else
							{
								$out = $API->selectTrip(isset($_GET['par'][3])?trim($_GET['par'][3]):'',NULL,isset($_REQUEST['orders'])?trim($_REQUEST['orders']):"",isset($_REQUEST['filter'])?$_REQUEST['filter']:NULL,isset($_REQUEST['fields'])?$_REQUEST['fields']:0,isset(taxi::$data_private['price_time_functions'])?taxi::$data_private['price_time_functions']:array());
							}
						}
						else
						{
							if ($_GET['par'][4] == 'ticket')
							{
								if (!empty($_GET['par'][5]))
								{
									if ($_GET['par'][5] == 'write')
									{
										$out = $API->writeTicket(trim($_GET['par'][3]),isset($_POST['data'])?$_POST['data']:'');
									}
									elseif ($_GET['par'][5] == 'read')
									{
										if (empty($_REQUEST['seat']))
										{
											$out = $API->readTicket(trim($_GET['par'][3]));
										}
										else
										{
											$out = $API->readTicket(trim($_GET['par'][3]),trim($_REQUEST['seat']),isset($_REQUEST['pdf'])?true:false,isset(taxi::$data['lang_vls'])?taxi::$data['lang_vls']:array(),isset(taxi::$data_private['price_time_functions'])?taxi::$data_private['price_time_functions']:array(),taxi::$data_stt);
										}
									}	
									elseif ($_GET['par'][5] == 'send')
									{
										if (!empty($_GET['par'][6]))
										{
											if ($_GET['par'][6] == 'buyer')
											{
												if (!empty($_GET['par'][7]))
												{
													if ($_GET['par'][7] == 'email')
													{
														$out = $API->sendToTicketBuyerEmail(isset($_REQUEST['resend'])?true:false,trim($_GET['par'][3]),isset($_REQUEST['seat'])?trim($_REQUEST['seat']):'',isset($_POST['subject'])?trim($_POST['subject']):'',isset($_POST['body'])?trim($_POST['body']):'',isset($_POST['file'])?$_POST['file']:'',isset($_REQUEST['u_id'])?trim($_REQUEST['u_id']):'',isset($_POST['u_name'])?trim($_POST['u_name']):NULL,isset($_POST['email'])?trim($_POST['email']):'',isset($_REQUEST['ignore_order'])?true:false,isset($_REQUEST['price'])?trim($_REQUEST['price']):NULL);
													}
												}
											}
										}
									}
									elseif ($_GET['par'][5] == 'edit')
									{
										$out = $API->editTicket(trim($_GET['par'][3]),isset($_POST['data'])?$_POST['data']:'',taxi::$data,taxi::$data_stt,taxi::$data_sc);
									}
								}
							}
						}
					}				
					elseif ($_GET['par'][2] == 'now')
					{
						$out = $API->selectTrip(NULL,'processing',isset($_REQUEST['orders'])?trim($_REQUEST['orders']):"",isset($_REQUEST['filter'])?$_REQUEST['filter']:NULL,isset($_REQUEST['fields'])?$_REQUEST['fields']:0,isset(taxi::$data_private['price_time_functions'])?taxi::$data_private['price_time_functions']:array());
					}
				}
			}
			elseif ($_GET['par'][1] == 'location')
			{
				if (isset($_POST['latitude']) && isset($_POST['longitude']))
				{
					check_auth_user(); $API->id_role = taxi::$id_role;
					$out = $API->setLocation(trim($_POST['latitude']),trim($_POST['longitude']));
				}
			}
			elseif ($_GET['par'][1] == 'token')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (empty($_GET['par'][3]))
				{
					$out = $API->selectToken(isset($_GET['par'][2])?trim($_GET['par'][2]):'',!empty($_SESSION['token_auth'])?array($_POST['token'],$_POST['u_hash']):array());

				}
			}
			elseif ($_GET['par'][1] == 'mail')
			{
				if (!empty($_GET['par'][3]))
				{
					if ($_GET['par'][3] == 'send')
					{
						$out = $API->sendMailToSite(isset(taxi::$data['site_emails'])?taxi::$data['site_emails']:array(),trim($_GET['par'][2]),isset($_POST['subject'])?trim($_POST['subject']):'',isset($_POST['body'])?trim($_POST['body']):'',isset($_POST['file'])?$_POST['file']:'');
					}
				}
			}
			elseif ($_GET['par'][1] == 'referral')
			{
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'code')
					{
						if (!empty($_GET['par'][3]))
						{
							if ($_GET['par'][4] == 'check')
							{
								$out = $API->checkReferralCode(trim($_GET['par'][3]));
							}
						}
					}
				}
			}
			elseif ($_GET['par'][1] == 'data')
			{
				if (isset($_POST['data']))
				{
					check_auth_user(); $API->id_role = taxi::$id_role;
					$out = $API->editData($_POST['data'],taxi::$data,taxi::$data_private,taxi::$data_stt,taxi::$data_sc);
				}
				elseif (isset($_REQUEST['private']))
				{
					check_auth_user(); $API->id_role = taxi::$id_role;
					$out = $API->selectDataPrivate(taxi::$data_private,isset($_REQUEST['json_like'])?$_REQUEST['json_like']:'');
				}
				elseif (empty($_REQUEST['fields']))
				{
					$out = $API->selectData(isset($_REQUEST['ucv'])?trim($_REQUEST['ucv']):NULL,taxi::$version,taxi::$data);
				}
				else
				{
					$out = $API->selectDataExt(trim($_REQUEST['fields']),isset($_REQUEST['easy'])?1:0,isset($_REQUEST['key'])?trim($_REQUEST['key']):false,empty($_REQUEST['nocache'])?false:true,isset($_REQUEST['team'])?trim($_REQUEST['team']):false,isset($_REQUEST['tournament'])?trim($_REQUEST['tournament']):false,isset($_REQUEST['ucv'])?trim($_REQUEST['ucv']):NULL,isset($_REQUEST['ucv2'])?trim($_REQUEST['ucv2']):NULL,isset($_REQUEST['ucv3'])?trim($_REQUEST['ucv3']):NULL,taxi::$version,taxi::$data,taxi::$version_stt,taxi::$data_stt,taxi::$version_sc,taxi::$data_sc);
				}
			}
			elseif ($_GET['par'][1] == 'push')
			{
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][3] == 'add')
					{
						$out = $API->addPush(isset($_POST['u_id'])?$_POST['u_id']:'',trim($_GET['par'][2]));
						header('Content-Type: application/json;charset=UTF-8');header('Access-Control-Allow-Origin: *');
						echo json_encode($out);
						exit;
					}
				}
			}
			elseif ($_GET['par'][1] == 'dropbox')
			{		
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'file')
					{
						if (empty($_GET['par'][3]))
						{
							if (isset($_POST['file']))
							{
								check_auth_user(); $API->id_role = taxi::$id_role;
								$out = $API->createDropboxFile($_POST['file']);
							}
						}
						else
						{
							if (empty($_GET['par'][4]))
							{
								check_auth_user(); $API->id_role = taxi::$id_role;
								$out = $API->selectDropboxFile(trim($_GET['par'][3]));
							}
							elseif ($_GET['par'][4] == 'del')
							{
								check_auth_user(); $API->id_role = taxi::$id_role;
								$out = $API->deleteDropboxFile(trim($_GET['par'][3]));
							}
							elseif ($_GET['par'][4] == 'select')
							{
								check_auth_user(); $API->id_role = taxi::$id_role;
								$out = $API->getDropboxFileData(trim($_GET['par'][3]),isset($_REQUEST['private'])?trim($_REQUEST['private']):'',isset($_REQUEST['deleted'])?trim($_REQUEST['deleted']):'');
							}
						}
					}
					elseif ($_GET['par'][2] == 'update')
					{
						if (isset($_REQUEST['code']) && !(empty($_POST['hash'])))
						{
							$out = $API->updateDropbox(trim($_REQUEST['code']),trim($_POST['hash']));
						}
					}
				}			
			}
			elseif ($_GET['par'][1] == 'cart')
			{
				check_auth_user(); $API->id_role = taxi::$id_role; 
				if (isset($_REQUEST['s_token'])) $API->session_token = trim($_REQUEST['s_token']); 
				if (empty($_GET['par'][2]))
				{
					if(empty($_REQUEST['prod']))
					{
						$out = $API->selectCart(isset($_REQUEST['filter'])?$_REQUEST['filter']:NULL);
					}
					else
					{
						$out = $API->updateCart(trim($_REQUEST['prod']),isset($_REQUEST['prop'])?trim($_REQUEST['prop']):NULL,isset($_REQUEST['count'])?(int)$_REQUEST['count']:1,isset($_POST['item'])?$_POST['item']:'');
					}
				}
				else
				{
					if ($_GET['par'][2] == 'clear')
					{
						$out = $API->clearCart(isset($_POST['item'])?$_POST['item']:'');
					}
					elseif ($_GET['par'][2] == 'move')
					{
						$out = $API->moveCart(isset($_POST['item'])?$_POST['item']:'',isset($_REQUEST['u_id'])?trim($_REQUEST['u_id']):NULL);
					}
				}
				$out['ticket_booking_duration'] = empty(taxi::$data['site_constants']['ticket_booking_duration'])?'':abs((int)taxi::$data['site_constants']['ticket_booking_duration']['value']);
			}
			elseif ($_GET['par'][1] == 'cart_block')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (empty($_GET['par'][2]))
				{
					if(empty($_REQUEST['prod']))
					{
						$out = $API->selectCartBlock(isset($_REQUEST['filter'])?$_REQUEST['filter']:NULL);
					}
					else
					{
						$out = $API->updateCartBlock(trim($_REQUEST['prod']),isset($_REQUEST['prop'])?trim($_REQUEST['prop']):NULL,isset($_REQUEST['count'])?(int)$_REQUEST['count']:1,isset($_REQUEST['notice'])?(empty($_REQUEST['notice'])?0:1):1,taxi::$data,taxi::$data_stt);
					}
				}
				else
				{
					if ($_GET['par'][2] == 'clear')
					{
						$out = $API->clearCartBlock(isset($_POST['item'])?$_POST['item']:'');
					}
					elseif ($_GET['par'][2] == 'status')
					{
						$out = $API->statusCartBlock(isset($_POST['data'])?$_POST['data']:'');
					}
				}
			}
			elseif ($_GET['par'][1] == 'query')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'template')
					{
						$out = $API->queryTemplate(isset($_POST['data'])?$_POST['data']:'',empty($_GET['par'][3])?'':trim($_GET['par'][3]),isset($_REQUEST['var'])?trim($_REQUEST['var']):NULL,isset(taxi::$data_private['sql_templates'])?taxi::$data_private['sql_templates']:array());
					}
					else
					{
						$out = $API->queryString(isset($_REQUEST['sql'])?trim($_REQUEST['sql']):'',trim($_GET['par'][2]),isset($_REQUEST['var'])?trim($_REQUEST['var']):NULL,empty(taxi::$data['site_constants']['query_roles'])?'':taxi::$data['site_constants']['query_roles']['value']);
					}
				}
			}
			elseif ($_GET['par'][1] == 'schedule')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (!empty($_GET['par'][2]) && $_GET['par'][2] == 'ticket')
				{
					if (empty($_GET['par'][3]))
					{
						$out = $API->selectTicket(isset($_REQUEST['sc_id'])?trim($_REQUEST['sc_id']):'');
					}
					elseif ($_GET['par'][3] == 'select')
					{
						$out = $API->getTicketData(isset($_REQUEST['sc_id'])?trim($_REQUEST['sc_id']):'',isset($_REQUEST['t_id'])?trim($_REQUEST['t_id']):'',isset($_REQUEST['seat'])?trim($_REQUEST['seat']):'',isset($_REQUEST['taken'])?true:false,isset($_REQUEST['code_qr'])?true:false,isset($_REQUEST['scheme'])?true:false,isset($_REQUEST['full'])?true:false,isset(taxi::$data['langs'])?taxi::$data['langs']:array(),isset(taxi::$data_private['price_time_functions'])?taxi::$data_private['price_time_functions']:array());
					}
				}
			}
			elseif ($_GET['par'][1] == 'email')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'verification')
					{
						if ($_GET['par'][3] == 'start')
						{
							$out = $API->startEmailVerification();
						}
						elseif ($_GET['par'][3] == 'complete')
						{
							$out = $API->completeEmailVerification(isset($_GET['ev_hash'])?trim($_GET['ev_hash']):'');
						}
					}
				}
			}
			elseif ($_GET['par'][1] == 'script')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'template')
					{
						$out = $API->includeTemplate(empty($_GET['par'][3])?'':trim($_GET['par'][3]),empty($_REQUEST['is_var'])?false:true,isset(taxi::$data_private['script_templates'])?taxi::$data_private['script_templates']:array());
					}
				}
			}
			elseif ($_GET['par'][1] == 'translate')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				$out = $API->translate(isset($_POST['data'])?$_POST['data']:'',isset($_POST['from'])?$_POST['from']:'',isset($_POST['to'])?$_POST['to']:'');
			}
			elseif ($_GET['par'][1] == 'outer_script')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'template')
					{
						$out = $API->requestTemplate(empty($_GET['par'][3])?'':trim($_GET['par'][3]),empty($_REQUEST['is_var'])?false:true,isset(taxi::$data_private['outer_script_templates'])?taxi::$data_private['outer_script_templates']:array());
					}
				}
			}
			elseif ($_GET['par'][1] == 'contact')
			{
				check_auth_user(); $API->id_role = taxi::$id_role;
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'get')
					{
						$out = $API->selectContact(isset($_POST['co_id'])?trim($_POST['co_id']):NULL,isset($_POST['u_id'])?trim($_POST['u_id']):NULL,isset($_POST['o_type'])?trim($_POST['o_type']):NULL,isset($_POST['co_class'])?trim($_POST['co_class']):NULL,isset(taxi::$data_private['owner_types'])?taxi::$data_private['owner_types']:array(),isset(taxi::$data['langs'])?taxi::$data['langs']:array());
					}
					elseif ($_GET['par'][2] == 'create')
					{
						$out = $API->createContact(isset($_POST['data'])?$_POST['data']:'',isset(taxi::$data['langs'])?taxi::$data['langs']:array());
					}
					elseif ($_GET['par'][2] == 'edit')
					{
						$out = $API->editContact(isset($_POST['data'])?$_POST['data']:'',isset($_REQUEST['co_id'])?trim($_REQUEST['co_id']):NULL,isset(taxi::$data['langs'])?taxi::$data['langs']:array());
					}
					elseif ($_GET['par'][2] == 'message')
					{
						if (!empty($_GET['par'][3]))
						{
							if ($_GET['par'][3] == 'get')
							{
								$out = $API->selectMessage(isset($_POST['m_id'])?trim($_POST['m_id']):NULL,isset($_POST['from_to'])?$_POST['from_to']:'',isset(taxi::$data_private['owner_types'])?taxi::$data_private['owner_types']:array());
							}
							elseif ($_GET['par'][3] == 'send')
							{
								$out = $API->sendMessage(isset($_POST['title'])?trim($_POST['title']):'',isset($_POST['text'])?trim($_POST['text']):'',isset($_POST['m_id'])?trim($_POST['m_id']):NULL,isset($_POST['m_type'])?trim($_POST['m_type']):NULL,isset($_POST['from_to'])?$_POST['from_to']:'',isset($_POST['co_ids'])?$_POST['co_ids']:'',isset($_POST['co_id'])?$_POST['co_id']:NULL,isset($_POST['code'])?$_POST['code']:NULL,isset(taxi::$data_private['owner_types'])?taxi::$data_private['owner_types']:array(),isset(taxi::$data['user_roles'])?taxi::$data['user_roles']:array());
							}
							elseif ($_GET['par'][3] == 'read')
							{
								$out = $API->readMessage(isset($_REQUEST['m_id'])?trim($_REQUEST['m_id']):NULL,isset(taxi::$data_private['owner_types'])?taxi::$data_private['owner_types']:array());
							}
						}
					}
				}
			}
			elseif ($_GET['par'][1] == 'task')
			{
				if (!empty($_GET['par'][2]))
				{
					check_auth_user(); $API->id_role = taxi::$id_role;
					if ($_GET['par'][2] == 'create')
					{
						$out = $API->createTask(isset($_POST['data'])?$_POST['data']:'');
					}
					elseif ($_GET['par'][2] == 'control')
					{
						$out = $API->controlTask(isset($_REQUEST['tl_id'])?trim($_REQUEST['tl_id']):NULL,isset($_REQUEST['action'])?trim($_REQUEST['action']):NULL);
					}
					elseif ($_GET['par'][2] == 'select')
					{
						$out = $API->selectTask(isset($_REQUEST['tl_id'])?trim($_REQUEST['tl_id']):NULL);
					}
					elseif ($_GET['par'][2] == 'log')
					{
						if (!empty($_GET['par'][3]))
						{
							if ($_GET['par'][3] == 'add')
							{
								$out = $API->addTaskLog(isset($_POST['data'])?$_POST['data']:'');
							}
							elseif ($_GET['par'][3] == 'get')
							{
								$out = $API->getTaskLog(isset($_REQUEST['tl_id'])?trim($_REQUEST['tl_id']):NULL);
							}
						}
					}
					elseif ($_GET['par'][2] == 'status')
					{
						$out = $API->setTaskStatus(isset($_REQUEST['tl_id'])?trim($_REQUEST['tl_id']):NULL,isset($_REQUEST['from_status'])?trim($_REQUEST['from_status']):NULL,isset($_REQUEST['to_status'])?trim($_REQUEST['to_status']):NULL);
					}
				}
			}
			elseif ($_GET['par'][1] == 'convert')
			{
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'html')
					{
						if (!empty($_GET['par'][3]))
						{
							if ($_GET['par'][3] == 'pdf')
							{
								$out = $API->htmlToPdf(isset($_POST['data'])?$_POST['data']:'');
							}
						}
					}
				}
			}
			elseif ($_GET['par'][1] == 'ticket')
			{
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'check')
					{
						check_auth_user(); $API->id_role = taxi::$id_role;
						$out = $API->checkTicket(isset($_REQUEST['code'])?trim($_REQUEST['code']):'');
					}				
				}
			}
			elseif ($_GET['par'][1] == 'promocode')
			{
				if (!empty($_GET['par'][2]))
				{
					if ($_GET['par'][2] == 'check')
					{
						check_auth_user(); $API->id_role = taxi::$id_role;
						$out = $API->selectPromocodeByValue(isset($_REQUEST['value'])?trim($_REQUEST['value']):'',isset($_REQUEST['count'])?trim($_REQUEST['count']):NULL);
					}				
				}
			}
		}
		if (isset($_REQUEST['cv'])) 
		{
			$out['cache version'] = taxi::$version;
			$out['cache version2'] = taxi::$version_stt;
			$out['cache version3'] = taxi::$version_sc;
		}
		if (isset($_REQUEST['au']) && !empty($_SESSION[UID]))
		{
			$_REQUEST['au'] = trim($_REQUEST['au']);
			if ($_REQUEST['au'] === '')
			{
				if (empty($out['auth_user']))
				{
					if (empty(taxi::$check_auth_user_count)) {check_auth_user(); $API->id_role = taxi::$id_role;}
					$out['auth_user'] = array(
											'u_id' => $_SESSION[UID],
											'u_name' => $_SESSION['name'],
											'u_family' => $_SESSION['family'],
											'u_middle' => $_SESSION['middle'],
											'u_email' => $_SESSION['email'],
											'u_phone' => $_SESSION['phone'],
											'u_role' => $_SESSION['id_role'],
											'u_a_role' => $API->id_role,
											'u_check_state' => $_SESSION['id_verification_status'],
											'u_ban' => $_SESSION['user_ban_status'],
											'u_active' => $_SESSION['active'],
											'u_photo' => $_SESSION['photo_link'],
											'u_birthday' => $_SESSION['birthday_date'],
											'u_lang' => $_SESSION['id_lang'], 
											'u_currency' => $_SESSION['currency'],
											'u_gps_software' => $_SESSION['id_navigation']
					);
				}
			}
			else
			{
				if ($_REQUEST['au'] === 'e')
				{
					if (empty($out['auth_user']) || !isset($out['auth_user']['u_description']))
					{
						if (empty($out['data']['user'][$_SESSION[UID]]))
						{
							if (empty(taxi::$check_auth_user_count)) {check_auth_user(); $API->id_role = taxi::$id_role;}
							$out['auth_user'] = $API->selectUser($_SESSION[UID]);						
							$out['auth_user'] = isset($out['auth_user']['data']['user'][$_SESSION[UID]]) ? $out['auth_user']['data']['user'][$_SESSION[UID]] : array('error'=>$out['auth_user']['message']);
						}
						else
						{
							$out['auth_user'] = $out['data']['user'][$_SESSION[UID]];
						}
						if (empty($out['auth_user']['error'])) $out['auth_user']['u_a_role'] = $API->id_role;
						unset($out['auth_user']['out_drive']);
						unset($out['auth_user']['out_address']);
						unset($out['auth_user']['out_latitude']);
						unset($out['auth_user']['out_longitude']);
						unset($out['auth_user']['out_est_datetime']);
						unset($out['auth_user']['out_s_address']);
						unset($out['auth_user']['out_s_latitude']);
						unset($out['auth_user']['out_s_longitude']);
						unset($out['auth_user']['out_passengers']);
						unset($out['auth_user']['out_luggage']);
						unset($out['auth_user']['ref_code']);
						unset($out['auth_user']['referrer_u_id']);
						unset($out['auth_user']['u_details']);
						unset($out['auth_user']['b_comments']);
						unset($out['auth_user']['b_services']);
						unset($out['auth_user']['b_location_classes']);
						unset($out['auth_user']['u_email_checked']);					
						unset($out['auth_user']['u_tg']);
						unset($out['auth_user']['u_tg_checked']);
						unset($out['auth_user']['u_upper']);
						unset($out['auth_user']['sc_id']);
						unset($out['auth_user']['u_wa']);
						unset($out['auth_user']['u_wa_checked']);
					}
				}
				elseif ($_REQUEST['au'] === 'f')
				{
					if (empty($out['data']['user'][$_SESSION[UID]]))
					{
						if (empty(taxi::$check_auth_user_count)) {check_auth_user(); $API->id_role = taxi::$id_role;}
						$out['auth_user'] = $API->selectUser($_SESSION[UID]);
						$out['auth_user'] = isset($out['auth_user']['data']['user'][$_SESSION[UID]]) ? $out['auth_user']['data']['user'][$_SESSION[UID]] : array('error'=>$out['auth_user']['message']);
					}
					else
					{
						$out['auth_user'] = $out['data']['user'][$_SESSION[UID]];
					}
					if (empty($out['auth_user']['error'])) $out['auth_user']['u_a_role'] = $API->id_role;
				}
			}
		}
		if (isset($_SESSION['token_auth']) && empty($_SESSION[UID])) 
		{
			$out['auth_error'] = 'wrong token or u_hash';
		}
	}

	header('Content-Type: application/json;charset=UTF-8');
	echo json_encode($out);
	die();
?>