<?php
if (isset($_GET['action']))
{
	switch (trim($_GET['action'])){
		case 'url':
			class site {public static $data = array();}
			@include_once('stripe_data.php');
			$site = isset($_REQUEST['site']) ? trim($_REQUEST['site']) : '';
			$c = isset($_REQUEST['c']) ? trim($_REQUEST['c']) : '';
			$order = isset($_REQUEST['order']) ? trim($_REQUEST['order']) : '';
			if (empty($order))
			{
				echo json_encode(array('error'=>'empty order'));break;
			}
			$amount = isset($_REQUEST['amount']) ? trim($_REQUEST['amount']) : '';
			if (empty($amount))
			{
				echo json_encode(array('error'=>'empty amount'));break;
			}
			$currency = isset($_REQUEST['currency']) ? trim($_REQUEST['currency']) : '';
			$redirect = isset($_REQUEST['redirect']) ? trim($_REQUEST['redirect']) : '';
			if (empty($redirect))
			{
				echo json_encode(array('error'=>'empty redirect'));break;
			}
			$key = isset($_REQUEST['key']) ? trim($_REQUEST['key']) : '';
			if (empty(site::$data[$site][$c][$order]))
			{
				site::$data[$site][$c][$order] = array(
							'amount'		=>		$amount,
							'currency'		=>		$currency,
							'redirect'		=>		$redirect,
							'key'			=>		$key,
							'status'		=>		'pending'
				);
				$php = '<?php site::$data = ' . var_export(site::$data,true) . ';';
				@$file = file_put_contents('stripe_data.php',$php);
				if (!$file) {echo json_encode(array('error'=>'data update failed'));break;}
				echo json_encode(array('url'=>$_SERVER['REQUEST_SCHEME'] . '://' . $_SERVER['HTTP_HOST'] . '/taxi/stub/stripe.php?action=pay&url='.urlencode(json_encode(array($site,$c,$order)))));break;
			}
			else
			{
				if (site::$data[$site][$c][$order]['key'] == $key)
				{
					switch (site::$data[$site][$c][$order]['status'])
					{
						case 'pending':
							echo json_encode(array('error'=>'pending order'));break 2;
						case 'succeeded':
							echo json_encode(array('error'=>'succeeded order'));break 2;
						case 'failed':
							echo json_encode(array('error'=>'failed order'));break 2;
						case 'processing':
							echo json_encode(array('error'=>'processing order'));break 2;
					}
				}
				else
				{
					echo json_encode(array('error'=>'wrong key'));break;
				}
			}
			break;
		case 'status':
			class site {public static $data = array();}
			@include_once('stripe_data.php');
			$site = isset($_REQUEST['site']) ? trim($_REQUEST['site']) : '';
			$c = isset($_REQUEST['c']) ? trim($_REQUEST['c']) : '';
			$order = isset($_REQUEST['order']) ? trim($_REQUEST['order']) : '';
			if (empty($order))
			{
				echo json_encode(array('error'=>'empty order'));break;
			}
			$hash = isset($_REQUEST['hash']) ? trim($_REQUEST['hash']) : '';
			if (empty(site::$data[$site][$c][$order]))
			{
				echo json_encode(array('error'=>'order not found'));break;
			}
			$key = site::$data[$site][$c][$order]['key'];	
			if ($hash != md5("$order$c$site$key")) 
			{
				echo json_encode(array('error'=>'wrong hash'));break;
			}
			echo json_encode(array('status'=>site::$data[$site][$c][$order]['status']));break;
			break;
		case 'pay':
			class site {public static $data = array();}
			@include_once('stripe_data.php');
			$url = isset($_REQUEST['url']) ? trim($_REQUEST['url']) : '';
			if (empty($url))
			{
				echo json_encode(array('error'=>'empty url'));break;
			}
			$url_str = $url;
			$url = json_decode($url,true);
			if (!isset($url[0]) || !isset($url[1]) || !isset($url[2]))
			{
				echo json_encode(array('error'=>'wrong url'));break;
			}
			$site = $url[0];
			$c = $url[1];
			$order = $url[2];
			if (empty(site::$data[$site][$c][$order]))
			{
				echo json_encode(array('error'=>'order not found'));break;
			}
			if (isset($_REQUEST['status']))
			{
				$status = isset($_REQUEST['status']) ? trim($_REQUEST['status']) : '';
				if (empty($_REQUEST['status']))
				{
					$status = 'failed';
				}
				else
				{
					$status = abs((int)$status);
					if ($status == 1) {$status = 'succeeded';} else {$status = 'processing';}
				}
				site::$data[$site][$c][$order]['status'] = $status;
				$php = '<?php site::$data = ' . var_export(site::$data,true) . ';';
				@$file = file_put_contents('stripe_data.php',$php);
				if (!$file) {echo json_encode(array('error'=>'data update failed'));break;}
				$redirect = site::$data[$site][$c][$order]['redirect'];
				$status = site::$data[$site][$c][$order]['status'];
				$key = site::$data[$site][$c][$order]['key'];
				$hash = md5("$order$c$site$status$key");
				$redirect = trim($redirect);
				if (($pos = strpos($redirect,'?')) === false)
				{
					$redirect = "$redirect?";
				}
				else
				{
					if ($pos != strlen($redirect)-1)
					{
						$redirect = "$redirect&";
					}
				}
				$redirect = "{$redirect}site=$site&c=$c&order=$order&status=$status&hash=$hash";
				header('Location: ' . $redirect);break;
			}
			else
			{
				?>			
<!DOCTYPE html>
<!--[if lt IE 7]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="ru"> <![endif]-->  
<!--[if IE 7]><html class="no-js lt-ie9 lt-ie8" lang="ru"> <![endif]-->  
<!--[if IE 8]><html class="no-js lt-ie9 ie8" lang="ru"> <![endif]-->  
<!--[if gt IE 8]><!--><html class="no-js" lang="ru"> <!--<![endif]--> 
<head>
    <meta charset="utf-8">
    <title>Оплата</title>
    <meta http-equiv="x-rim-auto-match" content="none">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
	<style>
		html,body{margin:0;padding:0;width:100%;height:100%;overflow:auto;font-size:14px;}
	</style>
</head>
<body>
	<form action="" method="GET" enctype="application/x-www-form-urlencoded;charset=UTF-8">
		<select name="status">
			<option value="1">succeeded</option>
			<option value="0">failed</option>
			<option value="2">processing</option>
		</select>
		<input type="hidden" name="action" value="pay">
		<input type="hidden" name="url" value="<?=htmlentities($url_str);?>">
		<input type="submit" value="ОК">
	</form>
</body>
</html>				
				<?
			}
			break;
		case 'endpoint':
			class site {public static $data = array();}
			@include_once('stripe_data.php');
			$url = isset($_REQUEST['url']) ? trim($_REQUEST['url']) : '';
			if (empty($url))
			{
				echo json_encode(array('error'=>'empty url'));break;
			}
			$status = isset($_REQUEST['status']) ? trim($_REQUEST['status']) : '';
			if (empty($status))
			{
				$status = 0;
			}
			else
			{
				$status = 1;
			}
			$url = json_decode($url,true);
			if (!isset($url[0]) || !isset($url[1]) || !isset($url[2]))
			{
				echo json_encode(array('error'=>'wrong url'));break;
			}
			$site = $url[0];
			$c = $url[1];
			$order = $url[2];
			if (empty(site::$data[$site][$c][$order]))
			{
				echo json_encode(array('error'=>'order not found'));break;
			}
			site::$data[$site][$c][$order]['status'] = $status == 0 ? 'failed' : 'succeeded';
			$php = '<?php site::$data = ' . var_export(site::$data,true) . ';';
			@$file = file_put_contents('stripe_data.php',$php);
			if (!$file) {echo json_encode(array('error'=>'data update failed'));break;}
			$endpoint = site::$data[$site][$c][$order]['endpoint'];
			$status = site::$data[$site][$c][$order]['status'];
			$key = site::$data[$site][$c][$order]['key'];
			$hash = md5("$order$c$site$status$key");

			$arr = array(
								'order'			=>		$order,
								'c'				=>		$c,
								'site'			=>		$site,
								'status'		=>		$status,
								'hash'			=>		$hash,		
			);
			$postvars = array();
			foreach($arr as $var_key=>$var_val)
			{
				$postvars[] = urlencode($var_key) . '=' . urlencode($var_val);
			}
			$postvars = implode('&',$postvars);
			$c = curl_init();
			curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c,CURLOPT_URL, $endpoint);
			curl_setopt($c,CURLOPT_POST, 1);
			curl_setopt($c,CURLOPT_POSTFIELDS,$postvars);
			curl_setopt($c,CURLOPT_CAINFO,'../config/cacert.pem');
			$headers = array(
				"Content-Type: application/x-www-form-urlencoded"
			);
			curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
			$response = curl_exec($c);
			curl_close($c);
			if (empty($response)) {echo json_encode(array('error'=>'empty response'));break;}
			echo 'success';
			break;
	}
}